-----------------------------------
--Copy and paste for chat windows--
-----------------------------------

local mmCopyFrame = CreateFrame("ScrollFrame", "mmCopyFrame", mmCopyFrame, "InputScrollFrameTemplate")
mmCopyFrame:Hide()
mmCopyFrame:SetToplevel(true)
mmCopyFrame:SetMovable(true)
mmCopyFrame:EnableMouse(true)
tinsert(UISpecialFrames, "mmCopyFrame")
mmCopyFrame:SetPoint("CENTER", UIParent, -100, 100)
mmCopyFrame:SetBackdropColor(1, 1, 1, 1)
mmCopyFrame.EditBox:SetBackdropColor(1, 1, 1, 1)
mmCopyFrame.CharCount:Hide()

function openMmCopyFrame(window, url)
	if (not window) then
		window = 1
	end
	mmCopyFrame:SetHeight(245)
	mmCopyFrame:SetWidth(400)
	local fontSize = false
	local channelInfo = ChatTypeInfo["CHANNEL" .. window]
	local guildChannelInfo = ChatTypeInfo["GUILD"]
	mmCopyFrame.EditBox:SetFont("Fonts\\ARIALN.ttf", 11)
	mmCopyFrame.EditBox:SetText("")
	if (url) then
		mmCopyFrame.EditBox:Insert(url)
		mmCopyFrame:SetHeight(45)
		mmCopyFrame.EditBox:HighlightText()
		mmCopyFrame.EditBox:SetFocus()
	else
		for i = 1, _G["ChatFrame" .. window]:GetNumMessages() do
			local currentMsg, r, g, b, chatTypeID = _G["ChatFrame" .. window]:GetMessageInfo(i)
			local colorCode = false
			currentMsg = removeChatJunk(currentMsg)
			if (r and g and b and chatTypeID) then
				--Format chat colors so they look the same as in chat window.
				colorCode = RGBToColorCode(r, g, b)
				--Itemlinks end the color code completely so readd it after color changes.
				currentMsg = string.gsub(currentMsg, "|r", "|r" .. colorCode)
				--Add color code to the start of the msg.
				currentMsg = colorCode .. currentMsg
				--if (string.match(currentMsg, "Total time played")) then
				--	mmCopyFrame.EditBox:Insert(colorCode .. " test")
				--end
			end
			--Color guild MOTD, it gives no valid RGB dunno why.
			if (string.match(currentMsg, "Guild Message of the Day: ")) then
				--mmCopyFrame.EditBox:Insert(RGBTableToColorCode(ChatTypeInfo.GUILD) .. currentMsg)
				currentMsg = RGBTableToColorCode(ChatTypeInfo.GUILD) .. currentMsg
			end
			if (i == 1) then
				mmCopyFrame.EditBox:Insert(currentMsg .. "|r")
			else
				mmCopyFrame.EditBox:Insert("\n" .. currentMsg .. "|r")
			end
		end
	end
	mmCopyFrame.EditBox:SetWidth(mmCopyFrame:GetWidth() - 30)
	--mmCopyFrame:SetWidth(_G["ChatFrame" .. window].FontStringContainer:GetWidth())
	mmCopyFrameTopBar:SetWidth(mmCopyFrame:GetWidth() - 6)
	mmCopyFrame:Show()
	--If a url click then set focus to the frame so all you need to do is ctrl+c.
	if (url) then
		mmCopyFrame.EditBox:SetFocus()
	end
end

--Remove certain escape sequences
function removeChatJunk(currentMsg)
	--Blizzard uses these (Arg1 or Arg2) "|4Arg1:Arg2;" chat escapes for some time formats etc.
	--Example: Total time played: 151 |4day:days;, 3 |4hour:hours;, 42 |4minute:minutes;, 5 |4second:seconds;
	--Seems to be use Arg1 is value is 1 or Arg2 is value is > 1.
	--This escape sequence isn't parsed by ExitBox:Insert() in scroll frames so I have to fix it here.
	--I'm not good enough with lua regexp to do these all in 1 func :p
	local chatNumber = string.match(currentMsg, "(%d+) |4year:years;")
	if (chatNumber) then
		if (tonumber(number) == 0) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4year:years;", chatNumber .. " year")
		elseif (tonumber(chatNumber) > 1) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4year:years;", chatNumber .. " years")
		else
			currentMsg = currentMsg --Do nothing.
		end
	end
	local chatNumber = string.match(currentMsg, "(%d+) |4day:days;")
	if (chatNumber) then
		if (tonumber(number) == 0) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4day:days;", chatNumber .. " day")
		elseif (tonumber(chatNumber) > 1) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4day:days;", chatNumber .. " days")
		else
			currentMsg = currentMsg --Do nothing.
		end
	end
	local chatNumber = string.match(currentMsg, "(%d+) |4hour:hours;")
	if (chatNumber) then
		if (tonumber(number) == 0) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4hour:hours;", chatNumber .. " hour")
		elseif (tonumber(chatNumber) > 1) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4hour:hours;", chatNumber .. " hours")
		else
			currentMsg = currentMsg --Do nothing.
		end
	end
	local chatNumber = string.match(currentMsg, "(%d+) |4minute:minutes;")
	if (chatNumber) then
		if (tonumber(number) == 0) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4minute:minutes;", chatNumber .. " minute")
		elseif (tonumber(chatNumber) > 1) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4minute:minutes;", chatNumber .. " minutes")
		else
			currentMsg = currentMsg --Do nothing.
		end
	end
	local chatNumber = string.match(currentMsg, "(%d+) |4second:seconds;")
	if (chatNumber) then
		if (tonumber(number) == 0) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4second:seconds;", chatNumber .. " second")
		elseif (tonumber(chatNumber) > 1) then
			currentMsg = string.gsub(currentMsg, "(%d+) |4second:seconds;", chatNumber .. " seconds")
		else
			currentMsg = currentMsg --Do nothing.
		end
	end
	return currentMsg
end

--Top bar for the title
local mmCopyFrameTopBar = CreateFrame("Frame", "mmCopyFrameTopBar", mmCopyFrame, "ThinGoldEdgeTemplate")
mmCopyFrameTopBar:SetPoint("TOP", -8, 22)
mmCopyFrameTopBar:SetWidth(100)
mmCopyFrameTopBar:SetHeight(18)
mmCopyFrameTopBar.fs = mmCopyFrameTopBar:CreateFontString("topBarFS", "OVERLAY")
--mmCopyFrameTopBar.fs:SetFontObject(QuestDifficulty_Standard)
mmCopyFrameTopBar.fs:SetFont("Fonts\\ARIALN.ttf", 11)
mmCopyFrameTopBar.fs:SetText("MultiMod Chat Copy")
mmCopyFrameTopBar.fs:SetPoint("CENTER", 0, 0)
mmCopyFrameTopBar:SetMovable(true)
mmCopyFrameTopBar:EnableMouse(true)
mmCopyFrameTopBar:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self:GetParent().isMoving then
		self:GetParent():StartMoving();
		self:GetParent().isMoving = true;
	end
end)
mmCopyFrameTopBar:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self:GetParent().isMoving then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)
mmCopyFrameTopBar:SetScript("OnHide", function(self)
	if (self:GetParent().isMoving) then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)

--Top right X close button
local mmCopyFrameCloseButton = CreateFrame("Button", "mmCopyFrameCloseButton", mmCopyFrame, "UIPanelCloseButton")
mmCopyFrameCloseButton:SetPoint("TOPRIGHT", 12, 27)
mmCopyFrameCloseButton:SetWidth(29)
mmCopyFrameCloseButton:SetHeight(29)
mmCopyFrameCloseButton:SetScript("OnClick", function(self, arg)
	mmCopyFrame:Hide()
end)

--Bottom Close button
local mmCopyFrameBottomButton = CreateFrame("Button", "mmCopyFrameBottomButton", mmCopyFrame, "UIPanelButtonTemplate")
mmCopyFrameBottomButton:SetPoint("BOTTOM", 0, -23)
mmCopyFrameBottomButton:SetWidth(80)
mmCopyFrameBottomButton:SetHeight(22)
mmCopyFrameBottomButton:SetText("Close")
mmCopyFrameBottomButton:SetNormalFontObject("GameFontNormalSmall")
mmCopyFrameBottomButton:SetScript("OnClick", function(self, arg)
	mmCopyFrame:Hide()
end)

mmCopyFrameBottomButton:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self:GetParent().isMoving then
		self:GetParent():StartMoving();
		self:GetParent().isMoving = true;
	end
end)
mmCopyFrameBottomButton:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self:GetParent().isMoving then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)
mmCopyFrameBottomButton:SetScript("OnHide", function(self)
	if (self:GetParent().isMoving) then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)

function makeChatWindowButtons(i)
	local obj = CreateFrame("Button", "mmChatCopyIcon" .. i, _G['ChatFrame'..i])
	obj.bg = obj:CreateTexture(nil,	"ARTWORK")
	obj.bg:SetTexture("Interface\\AddOns\\Multimod\\Media\\copypaste")
	obj.bg:SetAllPoints(obj)
	obj:SetPoint("BOTTOMRIGHT", -2, -3)
	obj.texture = obj.bg
	obj:SetWidth(18)
	obj:SetHeight(18)
	obj:Hide()
	obj:SetScript("OnClick", function(self, arg)
		if mmCopyFrame:IsVisible() then
    		mmCopyFrame:Hide()
    	else
			openMmCopyFrame(i)
		end
	end)
	--Map marker tooltip showing players name on hover.
	obj.Tooltip = CreateFrame("FRAME", "mmChatCopyIconTT", obj, "TooltipBorderedFrameTemplate")
	obj.Tooltip:SetPoint("Top", 0, 25)
	obj.Tooltip.fs = obj.Tooltip:CreateFontString("mmChatCopyIconTTFS", "ARTWORK")
	obj.Tooltip.fs:SetFont("Fonts\\ARIALN.ttf", 12)
	obj.Tooltip.fs:SetText("Copy Chat")
	obj.Tooltip.fs:SetPoint("CENTER", 0.5, 0.5)
	local fswidth = obj.Tooltip.fs:GetStringWidth()
	local fsheight = obj.Tooltip.fs:GetStringHeight()
	obj.Tooltip:SetWidth(fswidth + 12)
	obj.Tooltip:SetHeight(fsheight + 8)
	obj.Tooltip:SetFrameLevel(1000)
    obj.Tooltip:SetFrameStrata("TOOLTIP")
	obj.Tooltip:Hide()
	--Show/Hide the click box when moving mouse curson in and out of the chat window.
	_G['ChatFrame'..i]:SetScript("OnEnter", function(self)
		if (Multimod.db.global.chat_copy) then
			obj:Show()
		end
	end)
	_G['ChatFrame'..i]:SetScript("OnLeave", function(self)
		obj:Hide()
		obj.Tooltip:Hide()
	end)
	--Need to run the Show() widget when entering the actual button too or it blinks.
	function obj.show()
		obj:Show()
		obj.Tooltip:Show()
	end
	function obj.hide()
		obj:Hide()
		obj.Tooltip:Hide()
	end
	obj:SetScript("OnEnter", obj.show)
	obj:SetScript("OnLeave", obj.hide)
end

for i=1, NUM_CHAT_WINDOWS do
	makeChatWindowButtons(i)
end

--Clickable website links.
function mmChatWebLinks(self, event, msg, author, ...)
	if (not Multimod.db.global.chat_url) then
		return
	end
	--Sort the domain list from longest to shortest so it matches longest first.
	--table.sort(mmChatWebLinksMatches, function(a,b) return #a>#b end)
	--This loop lags the wow client for a second so it's disabled, better to have more false links than lag
	--The domain array is huge and for some reason ChatFrame_AddMessageEventFilter calls this 10 times for 1 chat line sometimes :/
	--One day I may cleanup the domain list and add a throddle for the chat event filter so leaving it here commented out.
	--for i ,v in pairs(mmChatWebLinksMatches) do
		--Credit to https://stackoverflow.com/questions/23590304/finding-a-url-in-a-string-lua-pattern for this regexp.
		--local pattern = "(([%w_.~!*:@&+$/?%%#-]-)(%w[-.%w]*%.)(%w+)(:?)(%d*)(/?)([%w_.~!*:@&+$/?%%#=-]*))"
		--Modified slightly
		local pattern = "(([%w_.~!*:@&+$/?%%#-]-)(%w[-.%w]*%w%.)(%a)(%a+)(:?)(%d*)(/?)([%w_.~!*:@&+$/?%%#=-]*))"
		local match = string.match(msg, pattern)
		if (match) then
			local colorCode = "|cff" .. RGBToHex(Multimod.db.global.chat_url_color_r, Multimod.db.global.chat_url_color_g,
					Multimod.db.global.chat_url_color_b)
			local replace = colorCode .. "(|HmmCustomLink:url|h" .. match .. "|h)|r"
			msg = string.gsub(msg, pattern, replace)
			--Just matching 1 url per chat line for now.
			return false, msg, author, ...
		end
	--end
	return false, msg, author, ...
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", mmChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", mmChatWebLinks)


--Hook the chat link click func.
hooksecurefunc("ChatFrame_OnHyperlinkShow", function(...)
	chatFrame, link, text, button = ...
    if (link == "mmCustomLink:url") then
		createUrlLinkFrame(chatFrame, link, text, button)
	end
end)

--Thanks to Ellypse and TotalRP3 for helping with this.
--Insert our custom link type into blizzards SetHyperlink() func.
local OriginalSetHyperlink = ItemRefTooltip.SetHyperlink
function ItemRefTooltip:SetHyperlink(link, ...)
	if (link and link:sub(0, 12) == "mmCustomLink") then
		return
	end
	return OriginalSetHyperlink(self, link, ...)
end

--Open the chat copy frame with the url highlighted and focus set so all that's needed is ctrl+c.
function createUrlLinkFrame(chatFrame, link, text, button)
	openMmCopyFrame(1, text)
end

--Set chat options at logon.
function Multimod:updateChatOptions(value)
	if (Multimod.db.global.chat_disable_fade) then
		for i=1, NUM_CHAT_WINDOWS do
			_G['ChatFrame' .. i]:SetFading(false)
		end
	elseif (value == "disablefade") then
		for i=1, NUM_CHAT_WINDOWS do
			_G['ChatFrame' .. i]:SetFading(true)
		end
	end
end