--Open the options GUI
SLASH_MMOPTIONSCMD1, SLASH_MMOPTIONSCMD2 = '/multimod', '/mm';
function SlashCmdList.MMOPTIONSCMD(msg, editBox)
	if (msg == "help" or msg == "commands") then
		Multimod:showCommandList()
	elseif (msg == "" or msg == "options" or msg == "option" or msg == "menu") then
		InterfaceOptionsFrame_OpenToCategory("Multimod");
		InterfaceOptionsFrame_OpenToCategory("Multimod");
	else
		Multimod:chatPrefixMsg("Use \"/mm\" to open options and \"/mm help\" to show the commands list.")
	end
end

SLASH_MMOPTIONSTWOCMD1 = '/mmhelp';
function SlashCmdList.MMOPTIONSTWOCMD(msg, editBox)
	Multimod:showCommandList()
end

----------------------------------------
--Create options menu (/multimod, /mm)--
----------------------------------------
mmoptions = {
	name = "|TInterface\\AddOns\\Multimod\\Media\\logo32:22:22:0:5|t Multimod v" .. GetAddOnMetadata("Multimod", "Version"),
	handler = Multimod,
	type = 'group',
	args = {
		top_header = {
			type = "description",
			name = "|CffDEDE42Type \"/mm help\" or click button below for a commands list.",
			fontSize = "medium",
			order = 1,
		},
		commands_button = {
			type = "execute",
			name = "Command List",
			func = "showCommandList",
			order = 2,
		},
		general = {
			name = "General Options",
			desc = "Main options.",
			type = "group",
 			order = 3,
 			args = {
 				misc_header = {
					type = "header",
					name = "Scroll down for more options",
					order = 1,
				},
				role_confirm = {
					type = "toggle",
					name = "Hide Role Confirmation",
					desc = "After you join a custom group finder raid a box pops up telling you your role and won't dissapear " ..
							"until clicked, this gets rid of it.",
					order = 2,
					get = "getHideRoleConfirmation",
					set = "setHideRoleConfirmation",
				},
				insert_keystones = {
					type = "toggle",
					name = "Insert Keystones",
					desc = "Auto insert keystone when you open interface in a dungeon?",
					order = 3,
					get = "getInsertKeystones",
					set = "setInsertKeystones",
				},
				level_granted = {
					type = "toggle",
					name = "Granted Levels",
					desc = "Auto accept granted levels via recruit a friend?",
					order = 4,
					get = "getLevelGranted",
					set = "setLevelGranted",
				},
				auto_delete_text = {
					type = "toggle",
					name = "Auto Delete Text",
					desc = "When you delete an item this will put the DELETE text into the popup box so all " ..
							"you have to do is click to confirm deletion.",
					order = 5,
					get = "getAutoDeleteText",
					set = "setAutoDeleteText",
				},
				flash_wow_client = {
					type = "toggle",
					name = "Flash WoW Client",
					desc = "Flash the WoW client icon when minimized if important events happen like queue pops and invites etc?",
					order = 6,
					get = "getFlashWoWClient",
					set = "setFlashWoWClient",
				},
				skip_cut_scenes = {
					type = "toggle",
					name = "Skip Cut Scenes",
					desc = "Skip cut scenes and movies?",
					order = 7,
					get = "getSkipCutScenes",
					set = "setSkipCutScenes",
				},
				skip_enchanted_looms = {
					type = "toggle",
					name = "Enchanted Heirlooms",
					desc = "Should the /deletelooms command also delete enchanted heirlooms?",
					order = 10,
					get = "getDeleteLoomsEnchanted",
					set = "setDeleteLoomsEnchanted",
				},
				quest_log_count = {
					type = "toggle",
					name = "Quest Log Count",
					desc = "Should the quest log display how many quests you currenly have?",
					order = 11,
					get = "getQuestLogCount",
					set = "setQuestLogCount",
				},
				workorders_header = {
					type = "header",
					name = "Auto start work orders",
					order = 20,
				},
				work_orders_orderhall = {
					type = "toggle",
					name = "Order Hall",
					desc = "Auto start work orders when you open chat with Order Hall npcs?",
					order = 21,
					get = "getAutoWorkOrdersOrderHall",
					set = "setAutoWorkOrdersOrderHall",
				},
				work_orders_garrison = {
					type = "toggle",
					name = "Garrison",
					desc = "Auto start work orders when you open chat with Garrison npcs?",
					order = 22,
					get = "getAutoWorkOrdersGarrison",
					set = "setAutoWorkOrdersGarrison",
				},
				work_orders_nomi = {
					type = "toggle",
					name = "Nomi",
					desc = "Auto start work orders when you open chat with Nomi in dalaran? (disabled by default " ..
							"as there are different food options to start)",
					order = 23,
					get = "getAutoWorkOrdersNomi",
					set = "setAutoWorkOrdersNomi",
				},
				rolecheck_header = {
					type = "header",
					name = "Auto accept role checks",
					order = 30,
				},
				role_check = {
					type = "toggle",
					name = "All Role Checks",
					desc = "Accept all role check popups? (overrides the other options here)",
					order = 31,
					get = "getRoleCheck",
					set = "setRoleCheck",
				},
				role_check_timewalking = {
					type = "toggle",
					name = "Timewalking",
					desc = "Accept Timewalking role check popup?",
					order = 32,
					get = "getRoleCheckTimewalking",
					set = "setRoleCheckTimewalking",
				},
				role_check_love = {
					type = "toggle",
					name = "Love Dungeon",
					desc = "Accept Love is in the Air dungeon role check popup?",
					order = 33,
					get = "getRoleCheckLove",
					set = "setRoleCheckLove",
				},
				role_check_halloween = {
					type = "toggle",
					name = "Halloween Dungeon",
					desc = "Accept Halloween role check popup?",
					order = 34,
					get = "getRoleCheckHalloween",
					set = "setRoleCheckHalloween",
				},
				logon_header = {
					type = "header",
					name = "Things to run shortly after logon",
					order = 40,
				},
				logon_token = {
					type = "toggle",
					name = "Show Token Price",
					desc = "Show WoW token price at logon. You can also use /token to display this.",
					order = 41,
					get = "getLogonToken",
					set = "setLogonToken",
				},
				logon_invasion = {
					type = "toggle",
					name = "Show Invasion Timer",
					desc = "Tells you how long till next Broken Isles invasion starts or current finishes. You can also use /invasion to display this.",
					order = 42,
					get = "getLogonInvasion",
					set = "setLogonInvasion",
				},
				logon_delete_argus = {
					type = "toggle",
					name = "/deleteargus",
					desc = "Delete Argus junk.",
					order = 45,
					get = "getLogonDeleteArgus",
					set = "setLogonDeleteArgus",
				},
				logon_delete_armortokens = {
					type = "toggle",
					name = "/deleteat",
					desc = "Delete Armor Tokens from Argus, Unsullied armor tokens. (if you have shop open it will sell instead " ..
							"of delete, they are only worth 2g each though)",
					order = 46,
					get = "getLogonDeleteArmorTokens",
					set = "setLogonDeleteArmorTokens",
				},
				logon_delete_love = {
					type = "toggle",
					name = "/deletelove",
					desc = "Delete Love is in the Air junk.",
					order = 47,
					get = "getLogonDeleteLove",
					set = "setLogonDeleteLove",
				},
				logon_delete_halloween = {
					type = "toggle",
					name = "/deletehalloween",
					desc = "Delete Halloween junk.",
					order = 48,
					get = "getLogonDeleteHalloween",
					set = "setLogonDeleteHalloween",
				},
				logon_delete_xmas = {
					type = "toggle",
					name = "/deletexmas",
					desc = "Delete Winter Veil junk.",
					order = 49,
					get = "getLogonDeleteXmas",
					set = "setLogonDeleteXmas",
				},
				logon_scan = {
					type = "toggle",
					name = "/scan",
					desc = "Scans bags for higher than equipped items and prints them to chat.",
					order = 50,
					get = "getLogonScan",
					set = "setLogonScan",
				},
				logon_passloot = {
					type = "toggle",
					name = "Pass on loot",
					desc = "Pass on loot every logon, I usually set this on slave accounts when dungeon leveling so they don't get the roll " ..
							"popups. (personal loot still works)",
					order = 51,
					get = "getLogonPassLoot",
					set = "setLogonPassLoot",
				},
				autoaccept_header = {
					type = "header",
					name = "Auto accept group invites",
					order = 60,
				},
				autoaccept_allinvites = {
					type = "toggle",
					name = "All Invites",
					desc = "Auto join all group invites?",
					order = 61,
					get = "getAcceptGroupAllInvites",
					set = "setAcceptGroupAllInvites",
				},
				autoaccept_guildinvites = {
					type = "toggle",
					name = "Guild",
					desc = "Auto join all group invites?",
					order = 62,
					get = "getAcceptGroupGuildInvites",
					set = "setAcceptGroupGuildInvites",
				},
				autoaccept_friendinvites = {
					type = "toggle",
					name = "Friends",
					desc = "Auto join all group invites?",
					order = 63,
					get = "getAcceptGroupFriendInvites",
					set = "setAcceptGroupFriendInvites",
				},
				autoaccept_bnetfriendinvites = {
					type = "toggle",
					name = "Bnet Friends",
					desc = "Auto join all group invites?",
					order = 64,
					get = "getAcceptGroupBnetFriendInvites",
					set = "setAcceptGroupBnetFriendInvites",
				},
				autoaccept_notwhilequeued = {
					type = "toggle",
					name = "Not While Queued",
					desc = "Enable this to not join groups when you are in any type of dungeon/raid/pvp queue.",
					order = 65,
					get = "getAcceptGroupNotWhileQueued",
					set = "setAcceptGroupNotWhileQueued",
				},
				talking_head_header = {
					type = "header",
					name = "Talking Head Frame",
					order = 70,
				},
				talking_head_desc = {
					type = "description",
					name = "|CffDEDE42This is the window that pops up in the middle of the screen with a Talking Head when you enter a world" ..
							" quest area, it plays a voice and tells you what to do.\n\n|CffFFFFFFHOLD SHIFT TO DRAG",
					fontSize = "medium",
					order = 71,
				},
				talking_head_button = {
					type = "execute",
					name = "Drag Talking Head",
					desc = "Click this to make the Talking Head window popup so you can drag it, hold shift to drag.",
					func = "Custom_TalkingHeadFrame_PlayCurrent",
					order = 72,
				},
				talking_head_size = {
					type = "range",
					name = "Talking Head Size",
					desc = "How big should the Talking Head Frame be?",
					order = 73,
					get = "getTalkingHeadSize",
					set = "setTalkingHeadSize",
					min = 0.5,
					max = 1.5,
					softMin = 0.5,
					softMax = 1.5,
					step = 0.01,
				},
				talking_head_reset = {
					type = "execute",
					name = "Reset Talking Head",
					func = "resetTalkingHead",
					order = 74,
				},
				talking_head_reset_desc = {
					type = "description",
					name = "Note: Clicking the reset button will /reload the UI.",
					fontSize = "medium",
					order = 75,
				},
			},
		},
		chat = {
			name = "Chat",
			desc = "Chat options.",
			type = "group",
 			order = 10,
 			args = {
 				chat_header = {
					type = "header",
					name = "Chat options",
					order = 1,
				},
				chat_copy = {
					type = "toggle",
					name = "Chat Copy",
					desc = "Enable the chat copy button in bottom left of chat windows? (disable this if you have some other chat addon" ..
							" doing this and it conflicts)",
					order = 2,
					get = "getChatCopy",
					set = "setChatCopy",
				},
				chat_url = {
					type = "toggle",
					name = "Chat URL Links",
					desc = "Enable this to make website links in chat clickable. (disable this if you have some other chat addon" ..
							" doing this and it conflicts)",
					order = 3,
					get = "getChatUrl",
					set = "setChatUrl",
				},
				chat_url_color = {
					type = "color",
					name = "Chat Links Color",
					desc = "What color should be URL links be highlighted as?",
					order = 4,
					get = "getChatUrlColor",
					set = "setChatUrlColor",
					hasAlpha = false,
				},
				chat_msgs_color = {
					type = "color",
					name = "Multimod Chat Msgs",
					desc = "What color should the Multimod chat msgs be? (token price/invasion timer etc)",
					order = 5,
					get = "getChatMsgColor",
					set = "setChatMsgColor",
					hasAlpha = false,
				},
				reset_url_color = {
					type = "execute",
					name = "Reset Links Color",
					func = "resetChatUrlColor",
					order = 6,
				},
				reset_chat_color = {
					type = "execute",
					name = "Reset Multimod Color",
					func = "resetChatMsgColor",
					order = 7,
				},
				chat_disable_fade = {
					type = "toggle",
					name = "Disable Chat Fade",
					desc = "This disables chat fading out when you don't hover the window for a while.",
					order = 8,
					get = "getChatDisableFade",
					set = "setChatDisableFade",
				},
			},
		},	
		map = {
			name = "Map",
			desc = "Map options.",
			type = "group",
 			order = 15,
 			args = {
 				map_header = {
					type = "header",
					name = "Who can see you on the map",
					order = 1,
				},
				map_all = {
					type = "toggle",
					name = "All",
					desc = "All people that have this addon installed on your server can see you on the map.",
					order = 2,
					get = "getMapAll",
					set = "setMapAll",
				},
				map_guild = {
					type = "toggle",
					name = "Guild",
					desc = "Guild members that have this addon installed can see you on the map.",
					order = 3,
					get = "getMapGuild",
					set = "setMapGuild",
				},
				map_bnetfriends = {
					type = "toggle",
					name = "Bnet Friends",
					desc = "People on your battle.net list of the same faction that have this addon installed can see you on the map.",
					order = 4,
					get = "getMapBnetFriends",
					set = "setMapBnetFriends",
				},
				map_friends = {
					type = "toggle",
					name = "Normal Friends",
					desc = "People on your normal friends list that have this addon installed can see you on the map.",
					order = 5,
					get = "getMapFriends",
					set = "setMapFriends",
				},
				map_disable_broadcasting = {
					type = "toggle",
					name = "Disable Broadcasting",
					desc = "This will disable this map module from communicating at all, no location data will be broadcast, " ..
							"this overrides the other settings and switches off everything map related.",
					order = 6,
					get = "getMapDisableBroadcasting",
					set = "setMapDisableBroadcasting",
				},
				map_hidemarker_header = {
					type = "header",
					name = "Hide minimap icon when player is far away?",
					order = 10,
				},
				map_hide_minimarker_edge = {
					type = "toggle",
					name = "Hide Minimap Edge",
					desc = "This will hide the minimap markers from from being shown on the edge of the minimap when players are" ..
							" further away than the number of yards specified here.",
					order = 11,
					get = "getMapMarkerHideEdge",
					set = "setMapMarkerHideEdge",
				},
				map_hide_minimarker_edge_always = {
					type = "toggle",
					name = "No Edge Ever",
					desc = "Disable this to make minimap markers not stick to the edge of the map at all, markers will dissapear" ..
							" when players are not within your minimap range.",
					order = 12,
					get = "getMapMarkerHideEdgeAlways",
					set = "setMapMarkerHideEdgeAlways",
				},
				map_hide_minimarker_range = {
					type = "range",
					name = "Minimap Edge Distance",
					desc = "How far away are players before we remove them from the edge of the minimap? (in yards, 2500ish seems to" ..
							" be roughly an average zone)",
					order = 13,
					get = "getMapMarkerHideDistance",
					set = "setMapMarkerHideDistance",
					min = 50,
					max = 5000,
					softMin = 50,
					softMax = 5000,
					step = 50,
				},
				map_marker_header = {
					type = "header",
					name = "What player map markers will look like.",
					order = 20,
				},
				map_marker_style = {
					type = "select",
					name = "Map Marker Style",
					desc = "What the map markers for players will look like.",
					order = 21,
					get = "getMapMarker",
					set = "setMapMarker",
					values = {"Solid Color", "Thin Black Border", "Thick Black Border", "Thickest Black Border", 
							"Thin Orange Border", "Thin Orange Border", "Thickest Orange Border"},
					style = "dropdown",
				},
				map_icon_examples = {
					type = "description",
					name = "|CffDEDE42Examples: (Warlock purple icon) (may require /reload after changing)",
					order = 22,
				},
				map_icon_solidoclor = {
					type = "description",
					name = "|TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Solidcolor:50:50:0:0|t",
					order = 23,
				},
				map_icon_thinblack = {
					type = "description",
					name = "|TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thinblack:50:50:0:0|t" ..
							"  |TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thickblack:50:50:0:0|t" ..
							"  |TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thickestblack:50:50:0:0|t",
					order = 24,
				},
				map_icon_thinorange = {
					type = "description",
					name = "|TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thinorange:50:50:0:0|t" ..
							"  |TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thickorange:50:50:0:0|t" ..
							"  |TInterface\\AddOns\\Multimod\\Media\\Optionsmenu\\Thickestorange:50:50:0:0|t",
					order = 25,
				},
			},
		},
		--[[questtracker = {
			name = "Quest Tracker",
			desc = "Resize and move the Blizzard quest tracker.",
			type = "group",
 			order = 16,
 			args = {
				questtracker_header = {
					type = "header",
					name = "Quest Tracker Options",
					order = 1,
				},
				questtracker_move = {
					type = "toggle",
					name = "Moveable",
					desc = "Hold SHIFT to drag the quest tracker where you want.",
					order = 2,
					get = "getQuestTrackerMove",
					set = "setQuestTrackerMove",
				},
				questtracker_size = {
					type = "range",
					name = "Quest Tracker Size",
					desc = "How big should the Quest Tracker Frame be?",
					order = 3,
					get = "getQuestTrackerSize",
					set = "setQuestTrackerSize",
					min = 0.5,
					max = 1.5,
					softMin = 0.5,
					softMax = 1.5,
					step = 0.01,
				},
				questtracker_reset = {
					type = "execute",
					name = "Reset Quest Tracker",
					func = "resetQuestTracker",
					order = 6,
				},
				questtracker_reset_desc = {
					type = "description",
					name = "Note: Clicking the reset button will /reload the UI.",
					fontSize = "medium",
					order = 7,
				},
			},
		},--]]
		itembar = {
			name = "Items Bar",
			desc = "A bar of consumable items you can click, customisable with what items types you want on it.",
			type = "group",
 			order = 17,
 			args = {
 				itembar_desc = {
					type = "description",
					name = "|CffDEDE42The itembar is a row of buttons that automatically displays items of the types you choose so you can" ..
							" click them. It cycles through all items of that type each time you press it.\nShift + left click to drag the bar.",
					fontSize = "medium",
					order = 1,
				},
				itembar_header_premade = {
					type = "header",
					name = "Premade item bar buttons (enable/disable)",
					order = 2,
				},
				itembar_rep = {
					type = "toggle",
					name = "Reputation Items",
					desc = "Display a button for all reputation items.",
					order = 3,
					get = "getItemBarRep",
					set = "setItemBarRep",
				},
				itembar_at = {
					type = "toggle",
					name = "Armor Tokens",
					desc = "Display a button for all Unsullied/Dauntless Armor Tokens.",
					order = 4,
					get = "getItemBarAt",
					set = "setItemBarAt",
				},
				itembar_troops = {
					type = "toggle",
					name = "Argus Troops",
					desc = "Display a button for all order hall troops from argus.",
					order = 5,
					get = "getItemBarTroops",
					set = "setItemBarTroops",
				},
				itembar_ns = {
					type = "toggle",
					name = "Nethershard Items",
					desc = "Display a button for all nethershard items from the Broken Shore.",
					order = 6,
					get = "getItemBarNs",
					set = "setItemBarNs",
				},
				itembar_ap = {
					type = "toggle",
					name = "Artifact Power",
					desc = "Display a button for all artifact power items.",
					order = 7,
					get = "getItemBarAp",
					set = "setItemBarAp",
				},
				itembar_header_premade_options = {
					type = "header",
					name = "Premade item bar options",
					order = 15,
				},
				itembar_size = {
					type = "range",
					name = "Item Bar Size",
					desc = "How big should the Item Bar Frame be?",
					order = 16,
					get = "getItemBarSize",
					set = "setItemBarSize",
					min = 0.5,
					max = 1.5,
					softMin = 0.5,
					softMax = 1.5,
					step = 0.01,
				},
				itembar_tooltips = {
					type = "toggle",
					name = "Show Tooltips",
					desc = "Show tooltips when you hover the items on your buttons?",
					order = 17,
					get = "getItemBarToolTips",
					set = "setItemBarToolTips",
				},
				itembar_rep_bnet = {
					type = "toggle",
					name = "Include Bnet Rep Items",
					desc = "Include Bnet wide reputation items on the rep button? Disable this if you'd rather mail to alts or save them.",
					order = 18,
					get = "getItemBarRepBnet",
					set = "setItemBarRepBnet",
				},
				
				itembar_ns_bnet = {
					type = "toggle",
					name = "Include Bnet Nethershard Items",
					desc = "Include Bnet wide nethershard items on the nethershard button? Disabled by default," ..
							" these are worth quite a bit on the auctoin house.",
					order = 19,
					get = "getItemBarNsBnet",
					set = "setItemBarNsBnet",
				},
				itembar_at_relinquished = {
					type = "toggle",
					name = "Relinquished Armor Tokens (910)",
					desc = "Include Relinquished (ilvl 910) armor tokens on the armor tokens button?",
					order = 20,
					get = "getItemBarAtRelinquished",
					set = "setItemBarAtRelinquished",
				},
				itembar_at_unsullied = {
					type = "toggle",
					name = "Unsullied Armor Tokens (880)",
					desc = "Include Unsullied (ilvl 880) armor tokens on the armor tokens button?",
					order = 21,
					get = "getItemBarAtUnsullied",
					set = "setItemBarAtUnsullied",
				},
				itembar_at_dauntless = {
					type = "toggle",
					name = "Dauntless Armor Tokens (850)",
					desc = "Include Unsullied (ilvl 850) armor tokens on the armor tokens button?",
					order = 22,
					get = "getItemBarAtDauntless",
					set = "setItemBarAtDauntless",
				},
				itembar_header_custom1 = {
					type = "header",
					name = "Custom item button 1",
					order = 30,
				},
				itembar_custom_desc = {
					type = "description",
					name = "|CffDEDE42You can open any custom item lists by shift + right clicking on the itembar button. Scroll down to enable extra buttons.",
					fontSize = "medium",
					order = 31,
				},
				itembar_custom1 = {
					type = "toggle",
					name = "Show Custom Button 1",
					desc = "Display a button for your custom list of items.",
					order = 32,
					get = "getItemBarCustom1",
					set = "setItemBarCustom1",
				},
				itembar_custom_partial1 = {
					type = "toggle",
					name = "Partial Matches",
					desc = "Should the button include items that partial match your list? Untick this if you want exact item name matches.",
					order = 33,
					get = "getItemBarCustomPartial1",
					set = "setItemBarCustomPartial1",
				},
				itembar_custom_list_button1 = {
					type = "execute",
					name = "Item List (Button 1)",
					func = function() Multimod:showMmCustomButton(1) end,
					order = 34,
				},
				itembar_custom_list_input1 = {
					type = "input",
					name = "  Add Item  (Type or Drag)",
					desc = "Type the name of your item in the box and click ok, the item will then show up on the Custom button.",
					order = 35,
					get = "getItemBarCustomList1",
					set = "setItemBarCustomList1",
				},
				itembar_header_custom2 = {
					type = "header",
					name = "Custom item button 2",
					order = 40,
				},
				itembar_custom2 = {
					type = "toggle",
					name = "Show Custom Button 2",
					desc = "Display a button for your custom list of items.",
					order = 41,
					get = "getItemBarCustom2",
					set = "setItemBarCustom2",
				},
				itembar_custom_partial2 = {
					type = "toggle",
					name = "Partial Matches",
					desc = "Should the button include items that partial match your list? Untick this if you want exact item name matches.",
					order = 42,
					get = "getItemBarCustomPartial2",
					set = "setItemBarCustomPartial2",
				},
				itembar_custom_list_button2 = {
					type = "execute",
					name = "Item List (Button 2)",
					func = function() Multimod:showMmCustomButton(2) end,
					order = 43,
				},
				itembar_custom_list_input2 = {
					type = "input",
					name = "  Add Item  (Type or Drag)",
					desc = "Type the name of your item in the box and click ok, the item will then show up on the Custom button.",
					order = 44,
					get = "getItemBarCustomList2",
					set = "setItemBarCustomList2",
				},
				itembar_header_custom3 = {
					type = "header",
					name = "Custom item button 3",
					order = 50,
				},
				itembar_custom3 = {
					type = "toggle",
					name = "Show Custom Button 3",
					desc = "Display a button for your custom list of items.",
					order = 51,
					get = "getItemBarCustom3",
					set = "setItemBarCustom3",
				},
				itembar_custom_partial3 = {
					type = "toggle",
					name = "Partial Matches",
					desc = "Should the button include items that partial match your list? Untick this if you want exact item name matches.",
					order = 52,
					get = "getItemBarCustomPartial3",
					set = "setItemBarCustomPartial3",
				},
				itembar_custom_list_button3 = {
					type = "execute",
					name = "Item List (Button 3)",
					func = function() Multimod:showMmCustomButton(3) end,
					order = 53,
				},
				itembar_custom_list_input3 = {
					type = "input",
					name = "  Add Item  (Type or Drag)",
					desc = "Type the name of your item in the box and click ok, the item will then show up on the Custom button.",
					order = 54,
					get = "getItemBarCustomList3",
					set = "setItemBarCustomList3",
				},
				itembar_header_custom4 = {
					type = "header",
					name = "Custom item button 4",
					order = 60,
				},
				itembar_custom4 = {
					type = "toggle",
					name = "Show Custom Button 4",
					desc = "Display a button for your custom list of items.",
					order = 61,
					get = "getItemBarCustom4",
					set = "setItemBarCustom4",
				},
				itembar_custom_partial4 = {
					type = "toggle",
					name = "Partial Matches",
					desc = "Should the button include items that partial match your list? Untick this if you want exact item name matches.",
					order = 62,
					get = "getItemBarCustomPartial4",
					set = "setItemBarCustomPartial4",
				},
				itembar_custom_list_button4 = {
					type = "execute",
					name = "Item List (Button 4)",
					func = function() Multimod:showMmCustomButton(4) end,
					order = 63,
				},
				itembar_custom_list_input4 = {
					type = "input",
					name = "  Add Item  (Type or Drag)",
					desc = "Type the name of your item in the box and click ok, the item will then show up on the Custom button.",
					order = 64,
					get = "getItemBarCustomList4",
					set = "setItemBarCustomList4",
				},
				itembar_header_custom5 = {
					type = "header",
					name = "Custom item button 5",
					order = 70,
				},
				itembar_custom5 = {
					type = "toggle",
					name = "Show Custom Button 5",
					desc = "Display a button for your custom list of items.",
					order = 71,
					get = "getItemBarCustom5",
					set = "setItemBarCustom5",
				},
				itembar_custom_partial5 = {
					type = "toggle",
					name = "Partial Matches",
					desc = "Should the button include items that partial match your list? Untick this if you want exact item name matches.",
					order = 72,
					get = "getItemBarCustomPartial5",
					set = "setItemBarCustomPartial5",
				},
				itembar_custom_list_button5 = {
					type = "execute",
					name = "Item List (Button 5)",
					func = function() Multimod:showMmCustomButton(5) end,
					order = 73,
				},
				itembar_custom_list_input5 = {
					type = "input",
					name = "  Add Item  (Type or Drag)",
					desc = "Type the name of your item in the box and click ok, the item will then show up on the Custom button.",
					order = 74,
					get = "getItemBarCustomList5",
					set = "setItemBarCustomList5",
				},
			},
		},
		argus = {
			name = "Argus",
			desc = "Argus junk items to delete.",
			type = "group",
			order = 20,
			args = {
				argus_header = {
					type = "description",
					name = "|CffDEDE42Items to delete with /deleteargus, this command won't delete any mount/toy/pet if you don't already own it.",
					fontSize = "medium",
					order = 20,
				},
				argus_delete_eggs = {
					type = "toggle",
					name = "Fel-Spotted Eggs",
					desc = "Delete all Fel-Spotted Eggs that drop from the panther bosses.",
					order = 21,
					get = "getArgusEggs",
					set = "setArgusEggs",
				},
				argus_delete_muffins = {
					type = "toggle",
					name = "Carefully Hidden Muffin",
					desc = "Delete all Carefully Hidden Muffins that drop from Feasel the Muffin Thief, disabled by default as it can " ..
							 "contain an AP item and food buff. Pretty annoying constantly opening though I'd rather delete them " ..
							 "so the option is here.",
					order = 22,
					get = "getArgusMuffins",
					set = "setArgusMuffins",
				},
				argus_delete_radinax_gem = {
					type = "toggle",
					name = "Cracked Radinax Control Gem",
					desc = "Delete all Cracked Radinax Control Gem, temp mount with 3 charges.",
					order = 23,
					get = "getArgusRadinaxGem",
					set = "setArgusRadinaxGem",
				},
				argus_header_mounts = {
					type = "header",
					name = "Mounts",
					order = 25,
				},
				argus_delete_darkspore = {
					type = "toggle",
					name = "Darkspore Mana Ray",
					desc = "Drops from Fel-Spotted Egg.",
					order = 26,
					get = "getArgusDarkspore",
					set = "setArgusDarkspore",
				},
				argus_delete_felglow = {
					type = "toggle",
					name = "Felglow Mana Ray",
					desc = "Drops from Fel-Spotted Egg.",
					order = 27,
					get = "getArgusFelglow",
					set = "setArgusFelglow",
				},
				argus_delete_scint = {
					type = "toggle",
					name = "Scintillating Mana Ray",
					desc = "Drops from Fel-Spotted Egg.",
					order = 28,
					get = "getArgusScint",
					set = "setArgusScint",
				},
				argus_delete_vibrant = {
					type = "toggle",
					name = "Vibrant Mana Ray",
					desc = "Drops from Fel-Spotted Egg.",
					order = 29,
					get = "getArgusVibrant",
					set = "setArgusVibrant",
				},
				argus_delete_maddened = {
					type = "toggle",
					name = "Maddened Chaosrunner",
					desc = "Drops from Wrangler Kravos on Mac'Aree.",
					order = 30,
					get = "getArgusMaddened",
					set = "setArgusMaddened",
				},
				argus_delete_lambent = {
					type = "toggle",
					name = "Lambent Mana Ray",
					desc = "Drops from Venomtail Skyfin on Mac'Aree.",
					order = 31,
					get = "getArgusLambent",
					set = "setArgusLambent",
				},
				argus_delete_acid = {
					type = "toggle",
					name = "Acid Belcher",
					desc = "Drops from Skreeg the Devourer on Mac'Aree.",
					order = 32,
					get = "getArgusAcid",
					set = "setArgusAcid",
				},
				argus_delete_crimson = {
					type = "toggle",
					name = "Crimson Slavermaw",
					desc = "Drops from Blistermaw on Antoran Wastes.",
					order = 33,
					get = "getArgusCrimson",
					set = "setArgusCrimson",
				},
				argus_delete_vile = {
					type = "toggle",
					name = "Vile Fiend",
					desc = "Drops from Houndmaster Kerrax on Antoran Wastes.",
					order = 34,
					get = "getArgusVile",
					set = "setArgusVile",
				},
				argus_header_toys = {
					type = "header",
					name = "Toys",
					order = 40,
				},
				argus_delete_baarut = {
					type = "toggle",
					name = "Baarut the Brisk",
					desc = "Drops from Baruut the Bloodthirsty on Mac'Aree.",
					order = 41,
					get = "getArgusBaarut",
					set = "setArgusBaarut",
				},
				argus_delete_barrier = {
					type = "toggle",
					name = "Barrier Generator",
					desc = "Drops from Vigilant Kuro and Vigilant Thanos on Mac'Aree.",
					order = 42,
					get = "getArgusBarrier",
					set = "setArgusBarrier",
				},
				argus_delete_orb = {
					type = "toggle",
					name = "Legion Communication Orb",
					desc = "Drops from Doomcaster Suprax on Antoran Wastes.",
					order = 43,
					get = "getArgusOrb",
					set = "setArgusOrb",
				},
				argus_delete_blue = {
					type = "toggle",
					name = "Blue Conservatory Scroll",
					desc = "Drops from Instructor Tarahna on Mac'Aree.",
					order = 44,
					get = "getArgusBlue",
					set = "setArgusBlue",
				},
				argus_delete_red = {
					type = "toggle",
					name = "Red Conservatory Scroll",
					desc = "Drops from Instructor Tarahna on Mac'Aree.",
					order = 45,
					get = "getArgusRed",
					set = "setArgusRed",
				},
				argus_delete_yellow = {
					type = "toggle",
					name = "Yellow Conservatory Scroll",
					desc = "Drops from Instructor Tarahna on Mac'Aree.",
					order = 46,
					get = "getArgusYellow",
					set = "setArgusYellow",
				},
				argus_delete_sfe = {
					type = "toggle",
					name = "S.F.E. Interceptor",
					desc = "Drops from Squadron Commander Vishax on Antoran Wastes.",
					order = 47,
					get = "getArgusSFE",
					set = "setArgusSFE",
				},
				argus_delete_eye = {
					type = "toggle",
					name = "Sightless Eye",
					desc = "Drops from Rezira the Seer on Antoran Wastes.",
					order = 48,
					get = "getArgusEye",
					set = "setArgusEye",
				},
				argus_delete_spire = {
					type = "toggle",
					name = "Spire of Spite",
					desc = "Drops from Sister Subversia on Krokuun.",
					order = 49,
					get = "getArgusSpire",
					set = "setArgusSpire",
				},
				argus_delete_micro = {
					type = "toggle",
					name = "Micro-Artillery Controller",
					desc = "Drops from Wrath-Lord Yarez on Antoran Wastes, vendors for 20g so disabled by default.",
					order = 50,
					get = "getArgusMicro",
					set = "setArgusMicro",
				},
				argus_delete_holy = {
					type = "toggle",
					name = "Holy Lightsphere",
					desc = "Drops from the Army of the Light exalted reputation paragon box, vendors for 10g so disabled by default.",
					order = 51,
					get = "getArgusHoly",
					set = "setArgusHoly",
				},
				argus_header_pets = {
					type = "header",
					name = "Pets",
					order = 60,
				},
				argus_delete_docile = {
					type = "toggle",
					name = "Docile Skyfin",
					desc = "Drops from Fel-Spotted Egg.",
					order = 61,
					get = "getArgusDocile",
					set = "setArgusDocile",
				},
				argus_delete_afflicted = {
					type = "toggle",
					name = "Fel-Afflicted Skyfin",
					desc = "Drops from Fel-Spotted Egg.",
					order = 62,
					get = "getArgusFelAfflicted",
					set = "setArgusFelAfflicted",
				},
				argus_delete_grasping = {
					type = "toggle",
					name = "Grasping Manifestation",
					desc = "Drops from Ataxon on Mac'Aree.",
					order = 63,
					get = "getArgusGrasping",
					set = "setArgusGrasping",
				},
				argus_delete_uunas_doll = {
					type = "toggle",
					name = "Uuna's Doll",
					desc = "Drops from The Many-Faced Devourer on Antoran Wastes.",
					order = 64,
					get = "getArgusUunasDoll",
					set = "setArgusUunasDoll",
				},
				argus_delete_fel_lasher = {
					type = "toggle",
					name = "Fel Lasher",
					desc = "Drops from herbing on Argus, disabled by default since it's worth a few gold AH.",
					order = 65,
					get = "getArgusFelLasher",
					set = "setArgusFelLasher",
				},
				argus_header_toys2 = {
					type = "description",
					name = "The pet Rebellious Imp is not included here as they are rarer drop.",
					fontSize = "small",
					order = 70,
				},
				argus_header_armor = {
					type = "header",
					name = "/deleteat",
					order = 72,
				},
				argus_header_armor2 = {
					type = "description",
					name = "|CffDEDE42Unsullied armor tokens from argus rares to destroy, if the shop is open it will sell them instead " ..
							"but they are only worth 2g each, unless you can be bothered mailing them to the right armor class " ..
							"alt to create and sell/de. There's far better ways to make gold in that time though!",
					fontSize = "medium",
					order = 73,
				},
				argus_unsullied_ring = {
					type = "toggle",
					name = "Unsullied Ring",
					desc = "Delete all Unsullied Rings.",
					order = 74,
					get = "getUnsulliedRing",
					set = "setUnsulliedRing",
				},
				argus_unsullied_necklace = {
					type = "toggle",
					name = "Unsullied Necklace",
					desc = "Delete all Unsullied Necklaces.",
					order = 75,
					get = "getUnsulliedNecklace",
					set = "setUnsulliedNecklace",
				},
				argus_unsullied_trinket = {
					type = "toggle",
					name = "Unsullied Trinket",
					desc = "Delete all Unsullied Trinkets.",
					order = 76,
					get = "getUnsulliedTrinket",
					set = "setUnsulliedTrinket",
				},
				argus_unsullied_cloak = {
					type = "toggle",
					name = "Unsullied Cloak",
					desc = "Delete all Unsullied Cloaks.",
					order = 77,
					get = "getUnsulliedCloak",
					set = "setUnsulliedCloak",
				},
				argus_unsullied_relic = {
					type = "toggle",
					name = "Unsullied Relic",
					desc = "Delete all Unsullied Relics.",
					order = 78,
					get = "getUnsulliedRelic",
					set = "setUnsulliedRelic",
				},
				argus_unsullied_cloth = {
					type = "toggle",
					name = "Unsullied Cloth",
					desc = "Delete all Unsullied Cloth armor parts.",
					order = 79,
					get = "getUnsulliedCloth",
					set = "setUnsulliedCloth",
				},
				argus_unsullied_leather = {
					type = "toggle",
					name = "Unsullied Leather",
					desc = "Delete all Unsullied Leather armor parts.",
					order = 80,
					get = "getUnsulliedLeather",
					set = "setUnsulliedLeather",
				},
				argus_unsullied_mail = {
					type = "toggle",
					name = "Unsullied Mail",
					desc = "Delete all Unsullied Mail armor parts.",
					order = 81,
					get = "getUnsulliedMail",
					set = "setUnsulliedMail",
				},
				argus_unsullied_plate = {
					type = "toggle",
					name = "Unsullied Plate",
					desc = "Delete all Unsullied Plate armor parts.",
					order = 82,
					get = "getUnsulliedPlate",
					set = "setUnsulliedPlate",
				},
				delete_dauntless_tokens = {
					type = "toggle",
					name = "Dauntless 850 tokens",
					desc = "Delete all old 850 Dauntless tokens from the Broken Shore",
					order = 83,
					get = "getDauntlessTokens",
					set = "setDauntlessTokens",
				},
			},
		},
		lovesisintheair = {
			name = "Love is in the Air",
			desc = "Love is in the Air options.",
			type = "group",
			order = 25,
			args = {
				leave_love = {
					type = "toggle",
					name = "Leave Love Dungeon",
					desc = "Auto leave the Love instance 5 seconds after the bosses are dead? " ..
							"Handy if you are just after the box you get soon as boss dies and farming mount on many chars.",
					order = 1,
					get = "getLeaveLove",
					set = "setLeaveLove",
				},
				leave_love_seconds = {
					type = "range",
					name = "Leave Delay Seconds",
					desc = "How many seconds after boss dies to leave the instance?",
					order = 3,
					get = "getLeaveLoveSeconds",
					set = "setLeaveLoveSeconds",
					min = 1,
					max = 30,
					softMin = 1,
					softMax = 30,
					step = 1,
				},
				love_autotalk = {
					type = "toggle",
					name = "Auto start encounter",
					desc = "Auto start the encounter when you open dialogue with the NPC?",
					order = 2,
					get = "getStartLove",
					set = "setStartLove",
				},
				love_header = {
					type = "header",
					name = "Items to delete with /deletelove",
					order = 20,
				},
				love_delete_ebonroses = {
					type = "toggle",
					name = "Bouquet of Ebon Roses",
					desc = "Delete Bouquet of Ebon Roses? (item that drops from dungeon bosses)",
					order = 21,
					get = "getLoveEbonRoses",
					set = "setLoveEbonRoses",
				},
				love_delete_redroses = {
					type = "toggle",
					name = "Bouquet of Red Roses",
					desc = "Delete Bouquet of Red Roses? (item that drops from dungeon bosses)",
					order = 21,
					get = "getLoveRedRoses",
					set = "setLoveRedRoses",
				},
				love_delete_rose = {
					type = "toggle",
					name = "Forever-Lovely Rose",
					desc = "Cosmetic head item.",
					order = 22,
					get = "getLoveLovelyRose",
					set = "setLoveLovelyRose",
				},
				love_delete_bravado = {
					type = "toggle",
					name = "\"Bravado\" Cologne",
					desc = "Cologne that drops from Headless Horsemen.",
					order = 23,
					get = "getLoveBravado",
					set = "setLoveBravado",
				},
				love_delete_enchantress = {
					type = "toggle",
					name = "\"Enchantress\" Perfume",
					desc = "Perfume that drops from Headless Horsemen.",
					order = 24,
					get = "getLoveEnchantress",
					set = "setLoveEnchantress",
				},
				love_delete_forever = {
					type = "toggle",
					name = "\"Forever\" Perfume",
					desc = "Perfume that drops from Headless Horsemen.",
					order = 25,
					get = "getLoveForever",
					set = "setLoveForever",
				},
				love_delete_stalwart = {
					type = "toggle",
					name = "\"STALWART\" Cologne",
					desc = "Cologne that drops from Headless Horsemen.",
					order = 26,
					get = "getLoveStalwart",
					set = "setLoveStalwart",
				},
				love_delete_victory = {
					type = "toggle",
					name = "\"VICTORY\" Perfume",
					desc = "Perfume that drops from Headless Horsemen.",
					order = 27,
					get = "getLoveVictory",
					set = "setLoveVictory",
				},
				love_delete_wizardry = {
					type = "toggle",
					name = "\"Wizardry\" Cologne",
					desc = "Cologne that drops from Headless Horsemen.",
					order = 28,
					get = "getLoveWizardry",
					set = "setLoveWizardry",
				},
				love_delete_heartcandies = {
					type = "toggle",
					name = "Bag of Heart Candies",
					desc = "Contains various candies for an achievement.",
					order = 29,
					get = "getLoveHeartCandies",
					set = "setLoveHeartCandies",
				},
				love_delete_boxofchocolates = {
					type = "toggle",
					name = "Box of Chocolates",
					desc = "Contains various chocolates for an achievement.",
					order = 30,
					get = "getLoveBoxOfChocolates",
					set = "setLoveBoxOfChocolates",
				},
				love_delete_greetingcard = {
					type = "toggle",
					name = "Faded Lovely Greeting Card",
					desc = "The quest start item that drops from Headless Horsemen.",
					order = 31,
					get = "getLoveGreetingCard",
					set = "setLoveGreetingCard",
				},
				love_delete_rosepetals = {
					type = "toggle",
					name = "Handful of Rose Petals",
					desc = "Achievement item.",
					order = 32,
					get = "getLoveRosePetals",
					set = "setLoveRosePetals",
				},
				love_delete_rocket = {
					type = "toggle",
					name = "Love Rocket",
					desc = "This is the useless white quality item \"Love Rocket\" NOT the mount.",
					order = 33,
					get = "getLoveRocket",
					set = "setLoveRocket",
				},
				love_delete_rocket = {
					type = "toggle",
					name = "The Heartbreaker",
					desc = "This is the toy that drops from the dungeon box, this doesn't delete if you don't own the toy already.",
					order = 34,
					get = "getLoveHeartbreaker",
					set = "setLoveHeartbreaker",
				},
				love_delete_rocket = {
					type = "toggle",
					name = "Toxic Wasteling",
					desc = "This pet drops from dungeon box and is usually worth nothing on the AH.",
					order = 35,
					get = "getLoveToxicWasteling",
					set = "setLoveToxicWasteling",
				},
				
			},
		},
		halloween = {
			name = "Halloween",
			desc = "Halloween options.",
			type = "group",
			order = 30,
			args = {
				leave_halloween = {
					type = "toggle",
					name = "Leave Halloween Dungeon",
					desc = "Auto leave the Halloween instance 5 seconds after the bosse is dead? " ..
							"Handy if you are just after the box you get soon as boss dies and farming mount on many chars.",
					order = 1,
					get = "getLeaveHalloween",
					set = "setLeaveHalloween",
				},
				halloween_autotalk = {
					type = "toggle",
					name = "Auto start encounter",
					desc = "Auto start the encounter when you open dialogue with the Pumpkin?",
					order = 2,
					get = "getStartHalloween",
					set = "setStartHalloween",
				},
				leave_halloween_seconds = {
					type = "range",
					name = "Leave Delay Seconds",
					desc = "How many seconds after boss dies to leave the instance?",
					order = 3,
					get = "getLeaveHalloweenSeconds",
					set = "setLeaveHalloweenSeconds",
					min = 1,
					max = 30,
					softMin = 1,
					softMax = 30,
					step = 1,
				},
				halloween_header = {
					type = "header",
					name = "Items to delete with /deletehalloween",
					order = 20,
				},
				halloween_delete_pennypouch = {
					type = "toggle",
					name = "Penny Pouch",
					desc = "Delete Penny Pouch? (useless 1 slot bag)",
					order = 21,
					get = "getHalloweenPennyPouch",
					set = "setHalloweenPennyPouch",
				},
				halloween_delete_wand = {
					type = "toggle",
					name = "Hallowed Wands",
					desc = "Delete Hallowed Wands? (temp changes targets appearence)",
					order = 22,
					get = "getHalloweenWand",
					set = "setHalloweenWand",
				},
				halloween_delete_malemask = {
					type = "toggle",
					name = "Male Masks",
					desc = "Delete Male Masks? (temp adds a race mask to appearence)",
					order = 23,
					get = "getHalloweenMaleMask",
					set = "setHalloweenMaleMask",
				},
				halloween_delete_femalemask = {
					type = "toggle",
					name = "Female Masks",
					desc = "Delete Female Masks? (temp adds a race mask to appearence)",
					order = 24,
					get = "getHalloweenFemaleMask",
					set = "setHalloweenFemaleMask",
				},
				halloween_delete_cinnamonball = {
					type = "toggle",
					name = "Pyroblast Cinnamon Ball",
					desc = "Delete Pyroblast Cinnamon Ball? (candy)",
					order = 25,
					get = "getHalloweenCinnamonBall",
					set = "setHalloweenCinnamonBall",
				},
				halloween_delete_gnerds = {
					type = "toggle",
					name = "G.N.E.R.D.S",
					desc = "Delete G.N.E.R.D.S? (candy)",
					order = 26,
					get = "getHalloweenGnerds",
					set = "setHalloweenGnerds",
				},
				halloween_delete_toothpick = {
					type = "toggle",
					name = "Tooth Pick",
					desc = "Delete Tooth Picks? (useless cosmetic buff)",
					order = 27,
					get = "getHalloweenToothPick",
					set = "setHalloweenToothPick",
				},
				halloween_delete_spearmintcandy = {
					type = "toggle",
					name = "Spearmint Candy ",
					desc = "Delete Soothing Spearmint Candy? (candy)",
					order = 28,
					get = "getHalloweenSpearmintCandy",
					set = "setHalloweenSpearmintCandy",
				},
				halloween_delete_feltaffy = {
					type = "toggle",
					name = "Fel Taffy",
					desc = "Delete Chewy Fel Taffy? (candy)",
					order = 29,
					get = "getHalloweenFelTaffy",
					set = "setHalloweenFelTaffy",
				},
				halloween_delete_lantern = {
					type = "toggle",
					name = "Lantern",
					desc = "Delete Weighted Jack-o'-Lantern? (useless cosmetic buff)",
					order = 30,
					get = "getHalloweenLantern",
					set = "setHalloweenLantern",
				},
				halloween_delete_hallowedhelm = {
					type = "toggle",
					name = "Hallowed Helm",
					desc = "Delete Hallowed Helm? (cosmetic helmet)",
					order = 31,
					get = "getHalloweenHallowedHelm",
					set = "setHalloweenHallowedHelm",
				},
				halloween_delete_sinistersquashling = {
					type = "toggle",
					name = "Sinister Squashling",
					desc = "Delete Sinister Squashling? (pet drop from Headless Horseman that sells for pretty much nothing usually)",
					order = 32,
					get = "getHalloweenSinisterSquashling",
					set = "setHalloweenSinisterSquashling",
				},
			},
		},
		winterveil = {
			name = "Winter Veil",
			desc = "Winter Veil options.",
			type = "group",
			order = 35,
			args = {
				garrison_dailies = {
					type = "toggle",
					name = "Garrison dailies",
					desc = "Auto get and hand in the 4 garrison dailies? All you have to do is talk to npc " ..
							"and this does the rest. Very handy if you do them on many alts.",
					order = 1,
					get = "getXmasGarrisonDailies",
					set = "setXmasGarrisonDailies",
				},
				xmas_header = {
					type = "header",
					name = "Items to delete with /deletexmas",
					order = 20,
				},
				xmas_delete_savagesnowball = {
					type = "toggle",
					name = "Savage Snowball",
					desc = "Delete Savage Snowball?",
					order = 21,
					get = "getXmasSavageSnowball",
					set = "setXmasSavageSnowball",
				},
			},
		},
		reset_frames = {
			name = "Reset Frame Positions",
			desc = "Buttons to reset frames this addon makes movable.",
			type = "group",
			order = 40,
			args = {
				reset_header = {
					type = "header",
					name = "Reset frames back to default position",
					order = 1,
				},
				talking_head_reset = {
					type = "execute",
					name = "Reset Talking Head Frame",
					func = "resetTalkingHead",
					order = 2,
					width = "full",
				},
				--questt_tracker_reset = {
				--	type = "execute",
				--	name = "Reset Quest Tracker Frame",
				--	func = "resetQuestTracker",
				--	order = 3,
					--width = "full",
				--},
				interface_options_reset = {
					type = "execute",
					name = "Reset Interface Options Frame",
					func = "resetInterfaceOptions",
					order = 4,
					width = "full",
				},
				reset_frames_desc = {
					type = "description",
					name = "Note: Clicking any reset button will /reload the UI.",
					fontSize = "medium",
					order = 5,
				},
			},
		},
	},
}

------------------------
--Load option defaults--
------------------------
option_defaults = {
	global = {
		--General options.
		role_check = true,
		role_check_love = true,
		role_check_halloween = true,
		role_check_timewalking = true,
		role_confirm = true,
		insert_keystones = true,
		level_granted = true,
		auto_delete_text = true,
		flash_wow_client = true,
		skip_cut_scenes = true,
		delete_looms_enchanted = false,
		quest_log_count = true,
		work_orders_orderhall = true,
		work_orders_garrison = true,
		work_orders_nomi = false,
		logon_token = true,
		logon_invasion = false,
		logon_delete_argus = false,
		logon_delete_armortokens = false,
		logon_delete_love = false,
		logon_delete_halloween = false,
		logon_delete_xmas = false,
		logon_scan = false,
		logon_passloot = false,
		autoaccept_allinvites = false,
		autoaccept_guildinvites = true,
		autoaccept_friendinvites = true,
		autoaccept_bnetfriendinvites = true,
		autoaccept_notwhilequeued = true,
		talking_head_size = 1,
		talking_head_point = nil,
		talking_head_relativePoint = nil,
		talking_head_x = nil,
		talking_head_y = nil,
		--Chat options.
		chat_copy = true,
		chat_url = true,
		chat_url_color_r = 0, chat_url_color_g = 173, chat_url_color_b = 255,
		chat_msg_color_r = 0, chat_msg_color_g = 255, chat_msg_color_b = 0,
		chat_disable_fade = true,
		--Map options.
		map_all = false,
		map_guild = true,
		map_bnetfriends = true,
		map_friends = true,
		map_disable_broadcasting = false,
		map_minimarker_edge = false,
		map_minimarker_edge_always = false,
		map_minimarker_edge_distance = 2500,
		map_marker_icon = 2,
		--Quest tracker.
		quest_tracker_move = false,
		quest_tracker_size = 1,
		--Item bar.
		itembar_size = 1,
		itembar_tooltips = true,
		itembar_rep = true,
		itembar_rep_bnet = true,
		itembar_troops = true,
		itembar_ap = true,
		itembar_at = true,
		itembar_at_relinquished = true,
		itembar_at_unsullied = true,
		itembar_at_dauntless = true,
		itembar_ns = true,
		itembar_ns_bnet = false,
		itembar_custom1 = true,
		itembar_custom2 = false,
		itembar_custom3 = false,
		itembar_custom4 = false,
		itembar_custom5 = false,
		itembar_custom_partial1 = true,
		itembar_custom_partial2 = true,
		itembar_custom_partial3 = true,
		itembar_custom_partial4 = true,
		itembar_custom_partial5 = true,
		--Argus.
		argus_eggs = true,
		argus_muffins = false,
		argus_darkspore = true,
		argus_felglow = true,
		argus_scint = true,
		argus_vibrant = true,
		argus_maddened = true,
		argus_lambent = true,
		argus_acid = true,
		argus_crimson = true,
		argus_vile = true,
		argus_baarut = true,
		argus_barrier = true,
		argus_orb = true,
		argus_blue = true,
		argus_red = true,
		argus_yellow = true,
		argus_sfe = true,
		argus_eye = true,
		argus_spire = true,
		argus_micro = false,
		argus_holy = false,
		argus_docile = true,
		argus_felafflicted = true,
		argus_grasping = true,
		argus_fel_lasher = false,
		argus_uunas_doll = true,
		argus_radinax_gem = true,
		delete_unsullied_ring = false,
		delete_unsullied_necklace = false,
		delete_unsullied_trinket = false,
		delete_unsullied_relic = false,
		delete_unsullied_relic = false,
		delete_unsullied_cloth = false,
		delete_unsullied_leather = false,
		delete_unsullied_mail = false,
		delete_unsullied_plate = false,
		delete_dauntless_tokens = false,
		--Love is in the air.
		leave_love = true,
		leave_love_seconds = 5,
		love_autotalk = true,
		love_ebonroses = true,
		love_redroses = true,
		love_lovelyrose = true,
		love_bravado = true,
		love_enchantress = true,
		love_forever = true,
		love_stalwart = true,
		love_victory = true,
		love_wizardry = true,
		love_heartcandies = true,
		love_boxofchocolates = true,
		love_greetingcard = true,
		love_rosepetals = true,
		love_rocket = true,
		love_heartbreaker = true,
		love_toxic_wasteling = true,
		--Halloween.
		leave_halloween = false,
		leave_halloween_seconds = 5,
		halloween_autotalk = true,
		halloween_pennypouch = true,
		halloween_wand = true,
		halloween_malemask = true,
		halloween_femalemask = true,
		halloween_cinnamonball = true,
		halloween_gnerds = true,
		halloween_toothpick = true,
		halloween_spearmintcandy = true,
		halloween_feltaffy = true,
		halloween_lantern = true,
		halloween_hallowedhelm = true,
		halloween_sinistersquashling = true,
		--Xmas.
		xmas_garrisondailies = true,
		xmas_savagesnowball = true,
	},
}

----------------------
--Load data defaults--
----------------------
data_defaults = {
	global = {
		keystones = {

		},
		itembar_custom_list1 = {

		},
		itembar_custom_list2 = {

		},
		itembar_custom_list3 = {

		},
		itembar_custom_list4 = {

		},
		itembar_custom_list5 = {

		},
	},
}

-------------------------------------------------------
--Below are the set and get functions for all options--
-------------------------------------------------------

--Auto accept role checks.
function Multimod:setRoleCheck(info, value)
	self.db.global.role_check = value;
end

function Multimod:getRoleCheck(info)
	return self.db.global.role_check;
end

function Multimod:setRoleCheckLove(info, value)
	self.db.global.role_check_love = value;
end

function Multimod:getRoleCheckLove(info)
	return self.db.global.role_check_love;
end

function Multimod:setRoleCheckHalloween(info, value)
	self.db.global.role_check_halloween = value;
end

function Multimod:getRoleCheckHalloween(info)
	return self.db.global.role_check_halloween;
end

function Multimod:setRoleCheckTimewalking(info, value)
	self.db.global.role_check_timewalking = value;
end

function Multimod:getRoleCheckTimewalking(info)
	return self.db.global.role_check_timewalking;
end

--Close role display window that pops up after you join a group finder raid.
function Multimod:setHideRoleConfirmation(info, value)
	self.db.global.role_confirm = value;
end

function Multimod:getHideRoleConfirmation(info)
	return self.db.global.role_confirm;
end

--Auto start work orders
function Multimod:setAutoWorkOrdersOrderHall(info, value)
	self.db.global.work_orders_orderhall = value;
end

function Multimod:getAutoWorkOrdersOrderHall(info)
	return self.db.global.work_orders_orderhall;
end

function Multimod:setAutoWorkOrdersGarrison(info, value)
	self.db.global.work_orders_garrison = value;
end

function Multimod:getAutoWorkOrdersGarrison(info)
	return self.db.global.work_orders_garrison;
end

function Multimod:setAutoWorkOrdersNomi(info, value)
	self.db.global.work_orders_nomi = value;
end

function Multimod:getAutoWorkOrdersNomi(info)
	return self.db.global.work_orders_nomi;
end

--Auto insert keystones?
function Multimod:setInsertKeystones(info, value)
	self.db.global.insert_keystones = value;
end

function Multimod:getInsertKeystones(info)
	return self.db.global.insert_keystones;
end

--Auto accept RAF granted levels?
function Multimod:setLevelGranted(info, value)
	self.db.global.level_granted = value;
end

function Multimod:getLevelGranted(info)
	return self.db.global.level_granted;
end

--Auto put DELETE text into delete confirmation boxes.
function Multimod:setAutoDeleteText(info, value)
	self.db.global.auto_delete_text = value;
end

function Multimod:getAutoDeleteText(info)
	return self.db.global.auto_delete_text;
end

--Flash wow client on important events when minimized.
function Multimod:setFlashWoWClient(info, value)
	self.db.global.flash_wow_client = value;
end

function Multimod:getFlashWoWClient(info)
	return self.db.global.flash_wow_client;
end

--Skip cut scenes.
function Multimod:setSkipCutScenes(info, value)
	self.db.global.skip_cut_scenes = value;
end

function Multimod:getSkipCutScenes(info)
	return self.db.global.skip_cut_scenes;
end

--Skip enchanted heirlooms.
function Multimod:setDeleteLoomsEnchanted(info, value)
	self.db.global.delete_looms_enchanted = value;
end

function Multimod:getDeleteLoomsEnchanted(info)
	return self.db.global.delete_looms_enchanted;
end

--Quest log count.
function Multimod:setQuestLogCount(info, value)
	self.db.global.quest_log_count = value;
	if (value == true) then
		local _, numQuests = GetNumQuestLogEntries();
		multimodQuestCount.fs:SetText("|cffFFFF00Quests:  (" .. numQuests .. "/25)")
		multimodQuestCount:Show()
	else
		multimodQuestCount:Hide()
	end
end

function Multimod:getQuestLogCount(info)
	return self.db.global.quest_log_count;
end

--Chat copy.
function Multimod:setChatCopy(info, value)
	self.db.global.chat_copy = value;
end

function Multimod:getChatCopy(info)
	return self.db.global.chat_copy;
end

--Chat url.
function Multimod:setChatUrl(info, value)
	self.db.global.chat_url = value;
end

function Multimod:getChatUrl(info)
	return self.db.global.chat_url;
end

--Chat url color.
function Multimod:setChatUrlColor(info, r, g, b, a)
	self.db.global.chat_url_color_r, self.db.global.chat_url_color_g, self.db.global.chat_url_color_b = r, g, b
	Multimod.chatColor = "|cff" .. RGBToHex(Multimod.db.global.chat_msg_color_r, Multimod.db.global.chat_msg_color_g, Multimod.db.global.chat_msg_color_b)
end

function Multimod:getChatUrlColor(info)
	return self.db.global.chat_url_color_r, self.db.global.chat_url_color_g, self.db.global.chat_url_color_b, self.db.global.chat_url_color_a
end

function Multimod:resetChatUrlColor()
	self.db.global.chat_url_color_r, self.db.global.chat_url_color_g, self.db.global.chat_url_color_b = 0, 173, 255
end

--Chat url color.
function Multimod:setChatMsgColor(info, r, g, b, a)
	self.db.global.chat_msg_color_r, self.db.global.chat_msg_color_g, self.db.global.chat_msg_color_b = r, g, b
end

function Multimod:getChatMsgColor(info)
	return self.db.global.chat_msg_color_r, self.db.global.chat_msg_color_g, self.db.global.chat_msg_color_b, self.db.global.chat_msg_color_a
end

function Multimod:resetChatMsgColor()
	self.db.global.chat_msg_color_r, self.db.global.chat_msg_color_g, self.db.global.chat_msg_color_b = 0, 255, 0
end

--Chat url.
function Multimod:setChatDisableFade(info, value)
	self.db.global.chat_disable_fade = value;
	if (value) then
		Multimod:updateChatOptions()
	else
		Multimod:updateChatOptions("disablefade")
	end
end

function Multimod:getChatDisableFade(info)
	return self.db.global.chat_disable_fade;
end

--Things to perform shortly after logon
function Multimod:setLogonToken(info, value)
	self.db.global.logon_token = value;
end

function Multimod:getLogonToken(info)
	return self.db.global.logon_token;
end

function Multimod:setLogonDeleteArgus(info, value)
	self.db.global.logon_delete_argus = value;
end

function Multimod:getLogonDeleteArgus(info)
	return self.db.global.logon_delete_argus;
end

function Multimod:setLogonDeleteArmorTokens(info, value)
	self.db.global.logon_delete_armortokens = value;
end

function Multimod:getLogonDeleteArmorTokens(info)
	return self.db.global.logon_delete_armortokens;
end

function Multimod:setLogonDeleteLove(info, value)
	self.db.global.logon_delete_love = value;
end

function Multimod:getLogonDeleteLove(info)
	return self.db.global.logon_delete_love;
end

function Multimod:setLogonDeleteHalloween(info, value)
	self.db.global.logon_delete_halloween = value;
end

function Multimod:getLogonDeleteHalloween(info)
	return self.db.global.logon_delete_halloween;
end

function Multimod:setLogonDeleteXmas(info, value)
	self.db.global.logon_delete_xmas = value;
end

function Multimod:getLogonDeleteXmas(info)
	return self.db.global.logon_delete_xmas;
end

function Multimod:setLogonScan(info, value)
	self.db.global.logon_scan = value;
end

function Multimod:getLogonScan(info)
	return self.db.global.logon_scan;
end

function Multimod:setLogonInvasion(info, value)
	self.db.global.logon_invasion = value;
end

function Multimod:getLogonInvasion(info)
	return self.db.global.logon_invasion;
end

function Multimod:setLogonPassLoot(info, value)
	self.db.global.logon_passloot = value;
end

function Multimod:getLogonPassLoot(info)
	return self.db.global.logon_passloot;
end

--Auto accept group invites
function Multimod:setAcceptGroupAllInvites(info, value)
	self.db.global.autoaccept_allinvites = value;
end

function Multimod:getAcceptGroupAllInvites(info)
	return self.db.global.autoaccept_allinvites;
end

function Multimod:setAcceptGroupGuildInvites(info, value)
	self.db.global.autoaccept_guildinvites = value;
end

function Multimod:getAcceptGroupGuildInvites(info)
	return self.db.global.autoaccept_guildinvites;
end

function Multimod:setAcceptGroupFriendInvites(info, value)
	self.db.global.autoaccept_friendinvites = value;
end

function Multimod:getAcceptGroupFriendInvites(info)
	return self.db.global.autoaccept_friendinvites;
end

function Multimod:setAcceptGroupBnetFriendInvites(info, value)
	self.db.global.autoaccept_bnetfriendinvites = value;
end

function Multimod:getAcceptGroupBnetFriendInvites(info)
	return self.db.global.autoaccept_bnetfriendinvites;
end

function Multimod:setAcceptGroupNotWhileQueued(info, value)
	self.db.global.autoaccept_notwhilequeued = value;
end

function Multimod:getAcceptGroupNotWhileQueued(info)
	return self.db.global.autoaccept_notwhilequeued;
end

function Multimod:setTalkingHeadSize(info, value)
	self.db.global.talking_head_size = value;
	TalkingHeadFrame:SetScale(value)
end

function Multimod:getTalkingHeadSize(info)
	return self.db.global.talking_head_size;
end

function Multimod:resetTalkingHead(info, value)
	TalkingHeadFrame:SetUserPlaced(false)
	self.db.global.talking_head_size = 1;
	self.db.global.talking_head_point = nil;
	self.db.global.talking_head_relativePoint = nil;
	self.db.global.talking_head_x = nil;
	self.db.global.talking_head_y = nil;
	ReloadUI();
end

-------
--Map--
-------

--Auto accept role checks.
function Multimod:setMapAll(info, value)
	self.db.global.map_all = value;
	if (value == false) then
		stopPublic()
		removeAllMarkers()
	end
	if (value == true) then
		sendMapUpdate(true)
	end
end

function Multimod:getMapAll(info)
	return self.db.global.map_all;
end

function Multimod:setMapGuild(info, value)
	self.db.global.map_guild = value;
	if (value == false) then
		stopPublic()
		stopGuild()
		removeAllMarkers()
	end
	if (value == true) then
		sendMapUpdate(true)
	end
end

function Multimod:getMapGuild(info)
	return self.db.global.map_guild;
end

function Multimod:setMapBnetFriends(info, value)
	self.db.global.map_bnetfriends = value;
	if (value == false) then
		stopPublic()
		sendBnetFriends("mmmap " .. mmNameAndServer .. ",stop")
		removeAllMarkers()
	end
	if (value == true) then
		sendMapUpdate(true)
	end
end

function Multimod:getMapBnetFriends(info)
	return self.db.global.map_bnetfriends;
end

function Multimod:setMapFriends(info, value)
	self.db.global.map_friends = value;
	if (value == false) then
		stopPublic()
		sendFriends("mmmap " .. mmNameAndServer .. ",stop")
		removeAllMarkers()
	end
	if (value == true) then
		sendMapUpdate(true)
	end
end

function Multimod:getMapFriends(info)
	return self.db.global.map_friends;
end

function Multimod:setMapDisableBroadcasting(info, value)
	self.db.global.map_disable_broadcasting = value;
	if (value == true) then
		stopBroadcasting()
		removeAllMarkers()
	end
	if (value == false) then
		sendMapUpdate(true)
	end
end

function Multimod:getMapDisableBroadcasting(info)
	return self.db.global.map_disable_broadcasting;
end

function Multimod:setMapMarkerHideEdge(info, value)
	self.db.global.map_minimarker_edge = value;
end

function Multimod:getMapMarkerHideEdge(info)
	return self.db.global.map_minimarker_edge;
end

function Multimod:setMapMarkerHideEdgeAlways(info, value)
	self.db.global.map_minimarker_edge_always = value;
end

function Multimod:getMapMarkerHideEdgeAlways(info)
	return self.db.global.map_minimarker_edge_always;
end

function Multimod:setMapMarkerHideDistance(info, value)
	self.db.global.map_minimarker_edge_distance = value;
end

function Multimod:getMapMarkerHideDistance(info)
	return self.db.global.map_minimarker_edge_distance;
end

function Multimod:setMapMarker(info, value)
	self.db.global.map_marker_icon = value;
	reloadMapMarkers()
end

function Multimod:getMapMarker(info)
	return self.db.global.map_marker_icon;
end

-----------------
--Quest Tracker--
-----------------

function Multimod:setQuestTrackerMove(info, value)
	self.db.global.quest_tracker_move = value;
end

function Multimod:getQuestTrackerMove(info)
	return self.db.global.quest_tracker_move;
end

function Multimod:setQuestTrackerSize(info, value)
	self.db.global.quest_tracker_size = value;
	ObjectiveTrackerFrame:SetScale(value)
	ObjectiveTrackerFrame:SetUserPlaced(false)
end

function Multimod:getQuestTrackerSize(info)
	return self.db.global.quest_tracker_size;
end

function Multimod:resetQuestTracker(info, value)
	ObjectiveTrackerFrame:SetUserPlaced(false)
	self.db.global.quest_tracker_size = 1;
	self.db.global.quest_tracker_point = nil;
	self.db.global.quest_tracker_relativePoint = nil;
	self.db.global.quest_tracker_x = nil;
	self.db.global.quest_tracker_y = nil;
	ReloadUI();
end

------------
--Item Bar--
------------

function Multimod:setItemBarSize(info, value)
	self.db.global.itembar_size = value;
	mmItemsParent:SetScale(value)
end

function Multimod:getItemBarSize(info)
	return self.db.global.itembar_size;
end

function Multimod:setItemBarToolTips(info, value)
	self.db.global.itembar_tooltips = value;
end

function Multimod:getItemBarToolTips(info)
	return self.db.global.itembar_tooltips;
end

function Multimod:setItemBarRep(info, value)
	self.db.global.itembar_rep = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarRep(info)
	return self.db.global.itembar_rep;
end

function Multimod:setItemBarRepBnet(info, value)
	self.db.global.itembar_rep_bnet = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarRepBnet(info)
	return self.db.global.itembar_rep_bnet;
end

function Multimod:setItemBarTroops(info, value)
	self.db.global.itembar_troops = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarTroops(info)
	return self.db.global.itembar_troops;
end

function Multimod:setItemBarAp(info, value)
	self.db.global.itembar_ap = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarAp(info)
	return self.db.global.itembar_ap;
end

function Multimod:setItemBarAt(info, value)
	self.db.global.itembar_at = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarAt(info)
	return self.db.global.itembar_at;
end

function Multimod:setItemBarAtRelinquished(info, value)
	self.db.global.itembar_at_relinquished = value;
	Multimod:createArmorTokensShared()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarAtRelinquished(info)
	return self.db.global.itembar_at_relinquished;
end

function Multimod:setItemBarAtUnsullied(info, value)
	self.db.global.itembar_at_unsullied = value;
	Multimod:createArmorTokensShared()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarAtUnsullied(info)
	return self.db.global.itembar_at_unsullied;
end

function Multimod:setItemBarAtDauntless(info, value)
	self.db.global.itembar_at_dauntless = value;
	Multimod:createArmorTokensShared()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarAtDauntless(info)
	return self.db.global.itembar_at_dauntless;
end

function Multimod:setItemBarNs(info, value)
	self.db.global.itembar_ns = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarNs(info)
	return self.db.global.itembar_ns;
end

function Multimod:setItemBarNsBnet(info, value)
	self.db.global.itembar_ns_bnet = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarNsBnet(info)
	return self.db.global.itembar_ns_bnet;
end

--Custom Button 1
function Multimod:setItemBarCustom1(info, value)
	self.db.global.itembar_custom1 = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustom1(info)
	return self.db.global.itembar_custom1;
end

function Multimod:setItemBarCustomPartial1(info, value)
	self.db.global.itembar_custom_partial1 = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomPartial1(info)
	return self.db.global.itembar_custom_partial1;
end

function Multimod:setItemBarCustomList1(info, value)
	--Store key as lower case for faster checking later.
	--But keep original value case for displaying later.
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list1[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list1[varValue] = value;
	end
	Multimod:createCustomButtonList(1)
	Multimod:updateItemButtons()
end

function Multimod:setItemBarCustomList1(info, value)
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list1[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list1[varValue] = value;
	end
	Multimod:createCustomButtonList(1)
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomList1(info)
	return self.data.global.itembar_custom_list1;
end

--Custom Button 2
function Multimod:setItemBarCustom2(info, value)
	self.db.global.itembar_custom2 = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustom2(info)
	return self.db.global.itembar_custom2;
end

function Multimod:setItemBarCustomPartial2(info, value)
	self.db.global.itembar_custom_partial2 = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomPartial2(info)
	return self.db.global.itembar_custom_partial2;
end

function Multimod:setItemBarCustomList2(info, value)
	--Store key as lower case for faster checking later.
	--But keep original value case for displaying later.
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list2[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list2[varValue] = value;
	end
	Multimod:createCustomButtonList(2)
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomList2(info)
	return self.data.global.itembar_custom_list2;
end

--Custom Button 3
function Multimod:setItemBarCustom3(info, value)
	self.db.global.itembar_custom3 = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustom3(info)
	return self.db.global.itembar_custom3;
end

function Multimod:setItemBarCustomPartial3(info, value)
	self.db.global.itembar_custom_partial3 = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomPartial3(info)
	return self.db.global.itembar_custom_partial3;
end

function Multimod:setItemBarCustomList3(info, value)
	--Store key as lower case for faster checking later.
	--But keep original value case for displaying later.
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list3[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list3[varValue] = value;
	end
	Multimod:createCustomButtonList(3)
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomList3(info)
	return self.data.global.itembar_custom_list3;
end

--Custom Button4
function Multimod:setItemBarCustom4(info, value)
	self.db.global.itembar_custom4 = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustom4(info)
	return self.db.global.itembar_custom4;
end

function Multimod:setItemBarCustomPartial4(info, value)
	self.db.global.itembar_custom_partial4 = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomPartial4(info)
	return self.db.global.itembar_custom_partial4;
end

function Multimod:setItemBarCustomList4(info, value)
	--Store key as lower case for faster checking later.
	--But keep original value case for displaying later.
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list4[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list4[varValue] = value;
	end
	Multimod:createCustomButtonList(4)
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomList4(info)
	return self.data.global.itembar_custom_list4;
end

--Custom Button 5
function Multimod:setItemBarCustom5(info, value)
	self.db.global.itembar_custom5 = value;
	Multimod:updateItemsFrame()
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustom5(info)
	return self.db.global.itembar_custom5;
end

function Multimod:setItemBarCustomPartial5(info, value)
	self.db.global.itembar_custom_partial5 = value;
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomPartial5(info)
	return self.db.global.itembar_custom_partial5;
end

function Multimod:setItemBarCustomList5(info, value)
	--Store key as lower case for faster checking later.
	--But keep original value case for displaying later.
	local itemName, itemLink = GetItemInfo(value)
	if (itemName and itemLink) then
		varValue = string.lower(itemName)
		self.data.global.itembar_custom_list5[varValue] = itemLink;
	else
		varValue = string.lower(value)
		self.data.global.itembar_custom_list5[varValue] = value;
	end
	Multimod:createCustomButtonList(5)
	Multimod:updateItemButtons()
end

function Multimod:getItemBarCustomList5(info)
	return self.data.global.itembar_custom_list5;
end
---------
--Argus--
---------

--Eggs
function Multimod:setArgusEggs(info, value)
	self.db.global.argus_eggs = value;
end

function Multimod:getArgusEggs(info)
	return self.db.global.argus_eggs;
end

--Muffins
function Multimod:setArgusMuffins(info, value)
	self.db.global.argus_muffins = value;
end

function Multimod:getArgusMuffins(info)
	return self.db.global.argus_muffins;
end

--Random Argus junk
function Multimod:setArgusRadinaxGem(info, value)
	self.db.global.argus_radinax_gem = value;
end

function Multimod:getArgusRadinaxGem(info)
	return self.db.global.argus_radinax_gem;
end

--Mounts
function Multimod:setArgusDarkspore(info, value)
	self.db.global.argus_darkspore = value;
end

function Multimod:getArgusDarkspore(info)
	return self.db.global.argus_darkspore;
end

function Multimod:setArgusFelglow(info, value)
	self.db.global.argus_felglow = value;
end

function Multimod:getArgusFelglow(info)
	return self.db.global.argus_felglow;
end

function Multimod:setArgusScint(info, value)
	self.db.global.argus_scint = value;
end

function Multimod:getArgusScint(info)
	return self.db.global.argus_scint;
end

function Multimod:setArgusVibrant(info, value)
	self.db.global.argus_vibrant = value;
end

function Multimod:getArgusVibrant(info)
	return self.db.global.argus_vibrant;
end

function Multimod:setArgusMaddened(info, value)
	self.db.global.argus_maddened = value;
end

function Multimod:getArgusMaddened(info)
	return self.db.global.argus_maddened;
end

function Multimod:setArgusLambent(info, value)
	self.db.global.argus_lambent = value;
end

function Multimod:getArgusLambent(info)
	return self.db.global.argus_lambent;
end

function Multimod:setArgusAcid(info, value)
	self.db.global.argus_acid = value;
end

function Multimod:getArgusAcid(info)
	return self.db.global.argus_acid;
end

function Multimod:setArgusCrimson(info, value)
	self.db.global.argus_crimson = value;
end

function Multimod:getArgusCrimson(info)
	return self.db.global.argus_crimson;
end

function Multimod:setArgusVile(info, value)
	self.db.global.argus_vile = value;
end

function Multimod:getArgusVile(info)
	return self.db.global.argus_vile;
end

--Toys
function Multimod:setArgusBaarut(info, value)
	self.db.global.argus_baarut = value;
end

function Multimod:getArgusBaarut(info)
	return self.db.global.argus_baarut;
end

function Multimod:setArgusBarrier(info, value)
	self.db.global.argus_barrier = value;
end

function Multimod:getArgusBarrier(info)
	return self.db.global.argus_barrier;
end

function Multimod:setArgusOrb(info, value)
	self.db.global.argus_orb = value;
end

function Multimod:getArgusOrb(info)
	return self.db.global.argus_orb;
end

function Multimod:setArgusBlue(info, value)
	self.db.global.argus_blue = value;
end

function Multimod:getArgusBlue(info)
	return self.db.global.argus_blue;
end

function Multimod:setArgusRed(info, value)
	self.db.global.argus_red = value;
end

function Multimod:getArgusRed(info)
	return self.db.global.argus_red;
end

function Multimod:setArgusYellow(info, value)
	self.db.global.argus_yellow = value;
end

function Multimod:getArgusYellow(info)
	return self.db.global.argus_yellow;
end

function Multimod:setArgusSFE(info, value)
	self.db.global.argus_sfe = value;
end

function Multimod:getArgusSFE(info)
	return self.db.global.argus_sfe;
end

function Multimod:setArgusEye(info, value)
	self.db.global.argus_eye = value;
end

function Multimod:getArgusEye(info)
	return self.db.global.argus_eye;
end

function Multimod:setArgusSpire(info, value)
	self.db.global.argus_spire = value;
end

function Multimod:getArgusSpire(info)
	return self.db.global.argus_spire;
end

function Multimod:setArgusMicro(info, value)
	self.db.global.argus_micro = value;
end

function Multimod:getArgusMicro(info)
	return self.db.global.argus_micro;
end

function Multimod:setArgusHoly(info, value)
	self.db.global.argus_holy = value;
end

function Multimod:getArgusHoly(info)
	return self.db.global.argus_holy;
end

--Pets
function Multimod:setArgusDocile(info, value)
	self.db.global.argus_docile = value;
end

function Multimod:getArgusDocile(info)
	return self.db.global.argus_docile;
end

function Multimod:setArgusFelAfflicted(info, value)
	self.db.global.argus_felafflicted = value;
end

function Multimod:getArgusFelAfflicted(info)
	return self.db.global.argus_felafflicted;
end

function Multimod:setArgusGrasping(info, value)
	self.db.global.argus_grasping = value;
end

function Multimod:getArgusGrasping(info)
	return self.db.global.argus_grasping;
end

function Multimod:setArgusFelLasher(info, value)
	self.db.global.argus_fel_lasher = value;
end

function Multimod:getArgusFelLasher(info)
	return self.db.global.argus_fel_lasher;
end

function Multimod:setArgusUunasDoll(info, value)
	self.db.global.argus_uunas_doll = value;
end

function Multimod:getArgusUunasDoll(info)
	return self.db.global.argus_uunas_doll;
end

--Armor tokens
function Multimod:setUnsulliedRing(info, value)
	self.db.global.delete_unsullied_ring = value;
end

function Multimod:getUnsulliedRing(info)
	return self.db.global.delete_unsullied_ring;
end

function Multimod:setUnsulliedNecklace(info, value)
	self.db.global.delete_unsullied_necklace = value;
end

function Multimod:getUnsulliedNecklace(info)
	return self.db.global.delete_unsullied_necklace;
end

function Multimod:setUnsulliedTrinket(info, value)
	self.db.global.delete_unsullied_trinket = value;
end

function Multimod:getUnsulliedTrinket(info)
	return self.db.global.delete_unsullied_trinket;
end

function Multimod:setUnsulliedCloak(info, value)
	self.db.global.delete_unsullied_cloak = value;
end

function Multimod:getUnsulliedCloak(info)
	return self.db.global.delete_unsullied_cloak;
end

function Multimod:setUnsulliedRelic(info, value)
	self.db.global.delete_unsullied_relic = value;
end

function Multimod:getUnsulliedRelic(info)
	return self.db.global.delete_unsullied_relic;
end

function Multimod:setUnsulliedCloth(info, value)
	self.db.global.delete_unsullied_cloth = value;
end

function Multimod:getUnsulliedCloth(info)
	return self.db.global.delete_unsullied_cloth;
end

function Multimod:setUnsulliedLeather(info, value)
	self.db.global.delete_unsullied_leather = value;
end

function Multimod:getUnsulliedLeather(info)
	return self.db.global.delete_unsullied_leather;
end

function Multimod:setUnsulliedMail(info, value)
	self.db.global.delete_unsullied_mail = value;
end

function Multimod:getUnsulliedMail(info)
	return self.db.global.delete_unsullied_mail;
end

function Multimod:setUnsulliedPlate(info, value)
	self.db.global.delete_unsullied_plate = value;
end

function Multimod:getUnsulliedPlate(info)
	return self.db.global.delete_unsullied_plate;
end

function Multimod:setDauntlessTokens(info, value)
	self.db.global.delete_dauntless_tokens = value;
end

function Multimod:getDauntlessTokens(info)
	return self.db.global.delete_dauntless_tokens;
end

----------------------
--Love is in the Air--
----------------------

--Auto leave the Love instance 5 seconds after fight ends.
function Multimod:setLeaveLove(info, value)
	self.db.global.leave_love = value;
end

function Multimod:getLeaveLove(info)
	return self.db.global.leave_love;
end

--How many seconds to leave the Love instance after fight ends (default 5).
function Multimod:setLeaveLoveSeconds(info, value)
	self.db.global.leave_love_seconds = value;
end

function Multimod:getLeaveLoveSeconds(info)
	return self.db.global.leave_love_seconds;
end

--Auto talk when opening chat with the Love instance npc to start the encounter.
function Multimod:setStartLove(info, value)
	self.db.global.love_autotalk = value;
end

function Multimod:getStartLove(info)
	return self.db.global.love_autotalk;
end

--Love is in the air items to delete.
function Multimod:setLoveEbonRoses(info, value)
	self.db.global.love_ebonroses = value;
end

function Multimod:getLoveEbonRoses(info)
	return self.db.global.love_ebonroses;
end

function Multimod:setLoveRedRoses(info, value)
	self.db.global.love_redroses = value;
end

function Multimod:getLoveRedRoses(info)
	return self.db.global.love_redroses;
end

function Multimod:setLoveLovelyRose(info, value)
	self.db.global.love_lovelyrose = value;
end

function Multimod:getLoveLovelyRose(info)
	return self.db.global.love_lovelyrose;
end

function Multimod:setLoveBravado(info, value)
	self.db.global.love_bravado = value;
end

function Multimod:getLoveBravado(info)
	return self.db.global.love_bravado;
end

function Multimod:setLoveEnchantress(info, value)
	self.db.global.love_enchantress = value;
end

function Multimod:getLoveEnchantress(info)
	return self.db.global.love_enchantress;
end

function Multimod:setLoveForever(info, value)
	self.db.global.love_forever = value;
end

function Multimod:getLoveForever(info)
	return self.db.global.love_forever;
end

function Multimod:setLoveStalwart(info, value)
	self.db.global.love_stalwart = value;
end

function Multimod:getLoveStalwart(info)
	return self.db.global.love_stalwart;
end

function Multimod:setLoveVictory(info, value)
	self.db.global.love_victory = value;
end

function Multimod:getLoveVictory(info)
	return self.db.global.love_victory;
end

function Multimod:setLoveWizardry(info, value)
	self.db.global.love_wizardry = value;
end

function Multimod:getLoveWizardry(info)
	return self.db.global.love_wizardry;
end

function Multimod:setLoveHeartCandies(info, value)
	self.db.global.love_heartcandies = value;
end

function Multimod:getLoveHeartCandies(info)
	return self.db.global.love_heartcandies;
end

function Multimod:setLoveBoxOfChocolates(info, value)
	self.db.global.love_boxofchocolates = value;
end

function Multimod:getLoveBoxOfChocolates(info)
	return self.db.global.love_boxofchocolates;
end

function Multimod:setLoveGreetingCard(info, value)
	self.db.global.love_greetingcard = value;
end

function Multimod:getLoveGreetingCard(info)
	return self.db.global.love_greetingcard;
end

function Multimod:setLoveRosePetals(info, value)
	self.db.global.love_rosepetals = value;
end

function Multimod:getLoveRosePetals(info)
	return self.db.global.love_rosepetals;
end

function Multimod:setLoveRocket(info, value)
	self.db.global.love_rocket = value;
end

function Multimod:getLoveRocket(info)
	return self.db.global.love_rocket;
end

function Multimod:setLoveHeartbreaker(info, value)
	self.db.global.love_heartbreaker = value;
end

function Multimod:getLoveHeartbreaker(info)
	return self.db.global.love_heartbreaker;
end

function Multimod:setLoveToxicWasteling(info, value)
	self.db.global.love_toxic_wasteling = value;
end

function Multimod:getLoveToxicWasteling(info)
	return self.db.global.love_toxic_wasteling;
end

-------------
--Halloween--
-------------

--Auto leave the Halloween instance 5 seconds after fight ends.
function Multimod:setLeaveHalloween(info, value)
	self.db.global.leave_halloween = value;
end

function Multimod:getLeaveHalloween(info)
	return self.db.global.leave_halloween;
end

--How many seconds to leave the Halloween instance after fight ends (default 5).
function Multimod:setLeaveHalloweenSeconds(info, value)
	self.db.global.leave_halloween_seconds = value;
end

function Multimod:getLeaveHalloweenSeconds(info)
	return self.db.global.leave_halloween_seconds;
end

--Auto talk when opening chat with the Halloween instance npc to start the encounter.
function Multimod:setStartHalloween(info, value)
	self.db.global.halloween_autotalk = value;
end

function Multimod:getStartHalloween(info)
	return self.db.global.halloween_autotalk;
end

--Halloween items to delete.
function Multimod:setHalloweenPennyPouch(info, value)
	self.db.global.halloween_pennypouch = value;
end

function Multimod:getHalloweenPennyPouch(info)
	return self.db.global.halloween_pennypouch;
end

function Multimod:setHalloweenWand(info, value)
	self.db.global.halloween_wand = value;
end

function Multimod:getHalloweenWand(info)
	return self.db.global.halloween_wand;
end

function Multimod:setHalloweenMaleMask(info, value)
	self.db.global.halloween_malemask = value;
end

function Multimod:getHalloweenMaleMask(info)
	return self.db.global.halloween_malemask;
end

function Multimod:setHalloweenFemaleMask(info, value)
	self.db.global.halloween_femalemask = value;
end

function Multimod:getHalloweenFemaleMask(info)
	return self.db.global.halloween_femalemask;
end

function Multimod:setHalloweenCinnamonBall(info, value)
	self.db.global.halloween_cinnamonball = value;
end

function Multimod:getHalloweenCinnamonBall(info)
	return self.db.global.halloween_cinnamonball;
end

function Multimod:setHalloweenGnerds(info, value)
	self.db.global.halloween_gnerds = value;
end

function Multimod:getHalloweenGnerds(info)
	return self.db.global.halloween_gnerds;
end

function Multimod:setHalloweenToothPick(info, value)
	self.db.global.halloween_toothpick = value;
end

function Multimod:getHalloweenToothPick(info)
	return self.db.global.halloween_toothpick;
end

function Multimod:setHalloweenSpearmintCandy(info, value)
	self.db.global.halloween_spearmintcandy = value;
end

function Multimod:getHalloweenSpearmintCandy(info)
	return self.db.global.halloween_spearmintcandy;
end

function Multimod:setHalloweenFelTaffy(info, value)
	self.db.global.halloween_feltaffy = value;
end

function Multimod:getHalloweenFelTaffy(info)
	return self.db.global.halloween_feltaffy;
end

function Multimod:setHalloweenLantern(info, value)
	self.db.global.halloween_lantern = value;
end

function Multimod:getHalloweenLantern(info)
	return self.db.global.halloween_lantern;
end

function Multimod:setHalloweenHallowedHelm(info, value)
	self.db.global.halloween_hallowedhelm = value;
end

function Multimod:getHalloweenHallowedHelm(info)
	return self.db.global.halloween_hallowedhelm;
end

function Multimod:setHalloweenSinisterSquashling(info, value)
	self.db.global.halloween_sinistersquashling = value;
end

function Multimod:getHalloweenSinisterSquashling(info)
	return self.db.global.halloween_sinistersquashling;
end

---------------
--Winter Veil--
---------------

--Auto start and hand in xmas garrison dailies.
function Multimod:setXmasGarrisonDailies(info, value)
	self.db.global.xmas_garrisondailies = value;
end

function Multimod:getXmasGarrisonDailies(info)
	return self.db.global.xmas_garrisondailies;
end

--Xmas items to delete.
function Multimod:setXmasSavageSnowball(info, value)
	self.db.global.xmas_savagesnowball = value;
end

function Multimod:getXmasSavageSnowball(info)
	return self.db.global.xmas_savagesnowball;
end

---------------------------------
--Reset Interface Options Frame--
---------------------------------

function Multimod:resetInterfaceOptions(info, value)
	InterfaceOptionsFrame:SetUserPlaced(false)
	ReloadUI();
end